'
' DotNetNuke - http://www.dotnetnuke.com
' Copyright (c) 2002-2005
' by Perpetual Motion Interactive Systems Inc. ( http://www.perpetualmotion.ca )
'
' Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated 
' documentation files (the "Software"), to deal in the Software without restriction, including without limitation 
' the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and 
' to permit persons to whom the Software is furnished to do so, subject to the following conditions:
'
' The above copyright notice and this permission notice shall be included in all copies or substantial portions 
' of the Software.
'
' THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED 
' TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL 
' THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF 
' CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
' DEALINGS IN THE SOFTWARE.
'

Imports System
Imports System.Configuration
Imports System.Data
Imports System.Globalization
Imports System.Xml.Serialization

Namespace DotNetNuke.Services.FileSystem

    ''' -----------------------------------------------------------------------------
	''' Project	 : DotNetNuke
	''' Class	 : FileInfo
	''' 
	''' -----------------------------------------------------------------------------
	''' <summary>
	''' Represents the File object and holds the Properties of that object
	''' </summary>
	''' <remarks>
	''' </remarks>
	''' <history>
	''' 	[DYNST]	2/1/2004	Created
	''' </history>
	''' -----------------------------------------------------------------------------
    <XmlRoot("file", IsNullable:=False)> Public Class FileInfo

        ''' -----------------------------------------------------------------------------
        ''' <summary>
        ''' The Primary Key ID of the current File, as represented within the Database table named "Files"
        ''' </summary>
        ''' <remarks>
        ''' This Integer Property is passed to the FileInfo Collection
        ''' </remarks>
        ''' <history>
        ''' 	[DYNST]	2/1/2004	Created
        ''' </history>
        ''' -----------------------------------------------------------------------------
        Private _FileId As Integer
        Private _PortalId As Integer
        Private _FileName As String
        Private _Extension As String
        Private _Size As Integer
        Private _Width As Integer
        Private _Height As Integer
        Private _ContentType As String
        Private _Folder As String

        Public Sub New()
        End Sub

        <XmlIgnore()> Public Property FileId() As Integer
            Get
                Return _FileId
            End Get
            Set(ByVal Value As Integer)
                _FileId = Value
            End Set
        End Property

        <XmlIgnore()> Public Property PortalId() As Integer
            Get
                Return _PortalId
            End Get
            Set(ByVal Value As Integer)
                _PortalId = Value
            End Set
        End Property

        <XmlElement("filename")> Public Property FileName() As String
            Get
                Return _FileName
            End Get
            Set(ByVal Value As String)
                _FileName = Value
            End Set
        End Property

        <XmlElement("extension")> Public Property Extension() As String
            Get
                Return _Extension
            End Get
            Set(ByVal Value As String)
                _Extension = Value
            End Set
        End Property

        <XmlElement("size")> Public Property Size() As Integer
            Get
                Return _Size
            End Get
            Set(ByVal Value As Integer)
                _Size = Value
            End Set
        End Property

        <XmlElement("width")> Public Property Width() As Integer
            Get
                Return _Width
            End Get
            Set(ByVal Value As Integer)
                _Width = Value
            End Set
        End Property

        <XmlElement("height")> Public Property Height() As Integer
            Get
                Return _Height
            End Get
            Set(ByVal Value As Integer)
                _Height = Value
            End Set
        End Property

        <XmlElement("contenttype")> Public Property ContentType() As String
            Get
                Return _ContentType
            End Get
            Set(ByVal Value As String)
                _ContentType = Value
            End Set
        End Property

        <XmlIgnore()> Public Property Folder() As String
            Get
                Return _Folder
            End Get
            Set(ByVal Value As String)
                _Folder = Value
            End Set
        End Property

    End Class

End Namespace
