'
' DotNetNuke - http://www.dotnetnuke.com
' Copyright (c) 2002-2005
' by Perpetual Motion Interactive Systems Inc. ( http://www.perpetualmotion.ca )
'
' Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated 
' documentation files (the "Software"), to deal in the Software without restriction, including without limitation 
' the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and 
' to permit persons to whom the Software is furnished to do so, subject to the following conditions:
'
' The above copyright notice and this permission notice shall be included in all copies or substantial portions 
' of the Software.
'
' THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED 
' TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL 
' THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF 
' CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
' DEALINGS IN THE SOFTWARE.
'

Imports System
Imports System.Configuration
Imports System.Data
Imports System.Globalization
Imports System.Web

Namespace DotNetNuke.Services.FileSystem
	''' -----------------------------------------------------------------------------
	''' Project	 : DotNetNuke
	''' Class	 : FolderController
	''' 
	''' -----------------------------------------------------------------------------
	''' <summary>
	''' Business Class that provides access to the Database for the functions within the calling classes
	''' Instantiates the instance of the DataProvider and returns the object, if any
	''' </summary>
	''' <remarks>
	''' </remarks>
	''' -----------------------------------------------------------------------------
	Public Class FolderController

		Public Function GetFoldersByPortal(ByVal PortalID As Integer) As ArrayList
			Return CBO.FillCollection(DataProvider.Instance().GetFoldersByPortal(PortalID), GetType(Services.FileSystem.FolderInfo))
		End Function

        Public Function GetFolder(ByVal PortalID As Integer, ByVal FolderPath As String) As FolderInfo
            Return CType(CBO.FillObject(DataProvider.Instance().GetFolder(PortalID, FolderPath), GetType(Services.FileSystem.FolderInfo)), FolderInfo)
        End Function

        Public Function GetFolder(ByVal PortalID As Integer, ByVal FolderID As Integer) As ArrayList
            Return CBO.FillCollection(DataProvider.Instance().GetFolder(PortalID, FolderID), GetType(Services.FileSystem.FolderInfo))
        End Function

        Public Function AddFolder(ByVal PortalID As Integer, ByVal FolderPath As String) As Integer

            Dim dr As IDataReader = DataProvider.Instance().GetFolder(PortalID, FolderPath)
            Dim FolderId As Integer
            If dr.Read Then
                FolderId = Convert.ToInt32(dr("FolderId"))
                DataProvider.Instance().UpdateFolder(PortalID, FolderId, FolderPath)
            Else
                FolderId = DataProvider.Instance().AddFolder(PortalID, FolderPath)
            End If
            dr.Close()

            Return FolderId

        End Function

        Public Sub UpdateFolder(ByVal objFolderInfo As FolderInfo)
            DataProvider.Instance().UpdateFolder(objFolderInfo.PortalID, objFolderInfo.FolderID, objFolderInfo.FolderPath)
        End Sub

        Public Sub DeleteFolder(ByVal PortalID As Integer, ByVal FolderPath As String)
            DataProvider.Instance().DeleteFolder(PortalID, FolderPath)
        End Sub

        Public Function GetMappedDirectory(ByVal VirtualDirectory As String) As String
            If DataCache.GetCache("DirMap:" + VirtualDirectory) Is Nothing Then
                SetMappedDirectory(VirtualDirectory)
            End If
            Return Convert.ToString(DataCache.GetCache("DirMap:" + VirtualDirectory))
        End Function

        Public Sub SetMappedDirectory(ByVal VirtualDirectory As String)
            Try
                Dim MappedDir As String = FileSystemUtils.AddTrailingSlash(HttpContext.Current.Server.MapPath(VirtualDirectory))
                DataCache.SetCache("DirMap:" + VirtualDirectory, MappedDir)
            Catch exc As Exception
                LogException(exc)
            End Try
        End Sub

        Public Sub SetMappedDirectory(ByVal VirtualDirectory As String, ByVal context As HttpContext)
            Try
                Dim MappedDir As String = FileSystemUtils.AddTrailingSlash(context.Server.MapPath(VirtualDirectory))
                DataCache.SetCache("DirMap:" + VirtualDirectory, MappedDir)
            Catch exc As Exception
                LogException(exc)
            End Try
        End Sub

        Public Sub SetMappedDirectory(ByVal portalInfo As PortalInfo, ByVal context As HttpContext)
            Try
                Dim VirtualDirectory As String = Common.Globals.ApplicationPath + "/" + portalInfo.HomeDirectory + "/"
                SetMappedDirectory(VirtualDirectory, context)

            Catch exc As Exception
                LogException(exc)
            End Try
        End Sub
    End Class

End Namespace
