'
' DotNetNuke - http://www.dotnetnuke.com
' Copyright (c) 2002-2005
' by Perpetual Motion Interactive Systems Inc. ( http://www.perpetualmotion.ca )
'
' Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated 
' documentation files (the "Software"), to deal in the Software without restriction, including without limitation 
' the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and 
' to permit persons to whom the Software is furnished to do so, subject to the following conditions:
'
' The above copyright notice and this permission notice shall be included in all copies or substantial portions 
' of the Software.
'
' THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED 
' TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL 
' THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF 
' CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
' DEALINGS IN THE SOFTWARE.
'
Imports System
Imports System.Xml
Imports System.Configuration
Imports System.Collections
Imports System.Reflection
Imports System.Diagnostics

Namespace DotNetNuke.Services.Upgrade

    ''' -----------------------------------------------------------------------------
    ''' <summary>
    ''' The Config class provides access to the web.config file
    ''' </summary>
    ''' <returns></returns>
    ''' <remarks>
    ''' </remarks>
    ''' <history>
    ''' </history>
    ''' -----------------------------------------------------------------------------
    Public Class Config

#Region "Public Methods"

        Public Function LoadConfig() As XmlDocument
            ' open the web.config file
            Dim xmlDoc As New XmlDocument
            xmlDoc.Load(Common.Globals.ApplicationMapPath & "\web.config")
            Return xmlDoc
        End Function

        Public Function SaveConfig(ByVal xmlDoc As XmlDocument) As String
            Try
                ' write the web.config file ( this will force an app restart )
                Dim writer As New XmlTextWriter(Common.Globals.ApplicationMapPath & "\web.config", Nothing)
                writer.Formatting = Formatting.Indented
                xmlDoc.WriteTo(writer)
                writer.Flush()
                writer.Close()
                Return ""
            Catch exc As Exception
                ' the file may be read-only or the file permissions may not be set properly
                Return exc.Message
            End Try
        End Function

        Public Function AddAppSetting(ByVal xmlDoc As XmlDocument, ByVal Key As String, ByVal Value As String) As XmlDocument

            Dim xmlElement As xmlElement

            ' retrieve the appSettings node 
            Dim xmlAppSettings As xmlNode = xmlDoc.SelectSingleNode("//appSettings")

            If Not xmlAppSettings Is Nothing Then
                ' get the node based on key
                Dim xmlNode As xmlNode = xmlAppSettings.SelectSingleNode(("//add[@key='" + Key + "']"))

                If Not xmlNode Is Nothing Then
                    ' update the existing element
                    xmlElement = CType(xmlNode, xmlElement)
                    xmlElement.SetAttribute("value", Value)
                Else
                    ' create a new element
                    xmlElement = xmlDoc.CreateElement("add")
                    xmlElement.SetAttribute("key", Key)
                    xmlElement.SetAttribute("value", Value)
                    xmlAppSettings.AppendChild(xmlElement)
                End If
            End If

            ' return the xml doc
            Return xmlDoc

        End Function

        Public Function RemoveAppSetting(ByVal xmlDoc As XmlDocument, ByVal Key As String) As XmlDocument

            ' retrieve the appSettings node 
            Dim xmlAppSettings As xmlNode = xmlDoc.SelectSingleNode("//appSettings")

            If Not xmlAppSettings Is Nothing Then
                ' get the node based on key
                Dim xmlNode As xmlNode = xmlAppSettings.SelectSingleNode(("//add[@key='" + Key + "']"))
                If Not xmlNode Is Nothing Then
                    ' remove the node
                    xmlAppSettings.RemoveChild(xmlNode)
                End If
            End If

            ' return the xml doc
            Return xmlDoc

        End Function

#End Region

    End Class

End Namespace
