'
' DotNetNuke - http://www.dotnetnuke.com
' Copyright (c) 2002-2005
' by Perpetual Motion Interactive Systems Inc. ( http://www.perpetualmotion.ca )
'
' Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated 
' documentation files (the "Software"), to deal in the Software without restriction, including without limitation 
' the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and 
' to permit persons to whom the Software is furnished to do so, subject to the following conditions:
'
' The above copyright notice and this permission notice shall be included in all copies or substantial portions 
' of the Software.
'
' THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED 
' TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL 
' THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF 
' CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
' DEALINGS IN THE SOFTWARE.
'
Imports System.Web

Imports DotNetNuke.Entities.Portals

Namespace DotNetNuke.Entities.Users
    Public Class UserTime

        Public Sub New()
        End Sub

        Public Function ConvertToUserTime(ByVal dt As DateTime, ByVal ClientTimeZone As Double) As DateTime
            ' Obtain PortalSettings from Current Context
            Dim _portalSettings As PortalSettings = PortalController.GetCurrentPortalSettings
            Return dt.AddMinutes(FromClientToServerFactor(ClientTimeZone, _portalSettings.TimeZoneOffset))
        End Function

        Public Function ConvertToServerTime(ByVal dt As DateTime, ByVal ClientTimeZone As Double) As DateTime
            ' Obtain PortalSettings from Current Context
            Dim _portalSettings As PortalSettings = PortalController.GetCurrentPortalSettings
            Return dt.AddMinutes(FromServerToClientFactor(ClientTimeZone, _portalSettings.TimeZoneOffset))
        End Function

        Public ReadOnly Property CurrentUserTime() As DateTime
            Get
                Dim context As HttpContext = HttpContext.Current
                If Not (context.Request.IsAuthenticated) Then
                    Return DateTime.Now
                Else
                    Return DateTime.Now.AddMinutes(ClientToServerTimeZoneFactor)
                End If
            End Get
        End Property

        Public ReadOnly Property ClientToServerTimeZoneFactor() As Double
            Get
                ' Obtain PortalSettings from Current Context
                Dim _portalSettings As PortalSettings = PortalController.GetCurrentPortalSettings
                Dim objUserInfo As UserInfo = UserController.GetCurrentUserInfo
                Return FromClientToServerFactor(objUserInfo.Profile.TimeZone, _portalSettings.TimeZoneOffset)
            End Get
        End Property

        Public ReadOnly Property ServerToClientTimeZoneFactor() As Double
            Get
                Dim objUser As UserInfo
                ' Obtain PortalSettings from Current Context
                Dim _portalSettings As PortalSettings = PortalController.GetCurrentPortalSettings
                Return FromServerToClientFactor(objUser.Profile.TimeZone, _portalSettings.TimeZoneOffset)
            End Get
        End Property

        Private Function FromClientToServerFactor(ByVal Client As Double, ByVal Server As Double) As Double
            Return Client - Server
        End Function

        Private Function FromServerToClientFactor(ByVal Client As Double, ByVal Server As Double) As Double
            Return Server - Client
        End Function

    End Class
End Namespace