'
' DotNetNuke - http://www.dotnetnuke.com
' Copyright (c) 2002-2005
' by Perpetual Motion Interactive Systems Inc. ( http://www.perpetualmotion.ca )
'
' Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated 
' documentation files (the "Software"), to deal in the Software without restriction, including without limitation 
' the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and 
' to permit persons to whom the Software is furnished to do so, subject to the following conditions:
'
' The above copyright notice and this permission notice shall be included in all copies or substantial portions 
' of the Software.
'
' THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED 
' TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL 
' THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF 
' CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
' DEALINGS IN THE SOFTWARE.
'

Imports System
Imports System.Configuration
Imports System.Data

Namespace DotNetNuke.Services.Vendors

	Public Class BannerController


		Public Function GetBanners(ByVal VendorId As Integer) As ArrayList

			Return CBO.FillCollection(DataProvider.Instance().GetBanners(VendorId), GetType(BannerInfo))

		End Function


		Public Function GetBanner(ByVal BannerId As Integer, ByVal VendorId As Integer, ByVal PortalId As Integer) As BannerInfo

			Return CType(CBO.FillObject(DataProvider.Instance().GetBanner(BannerId, VendorId,PortalId), GetType(BannerInfo)), BannerInfo)

		End Function


		Public Sub DeleteBanner(ByVal BannerId As Integer)

			DataProvider.Instance().DeleteBanner(BannerId)

		End Sub


		Public Sub AddBanner(ByVal objBannerInfo As BannerInfo)

            DataProvider.Instance().AddBanner(objBannerInfo.BannerName, objBannerInfo.VendorId, objBannerInfo.ImageFile, objBannerInfo.URL, objBannerInfo.Impressions, objBannerInfo.CPM, objBannerInfo.StartDate, objBannerInfo.EndDate, objBannerInfo.CreatedByUser, objBannerInfo.BannerTypeId, objBannerInfo.Description, objBannerInfo.GroupName, objBannerInfo.Criteria, objBannerInfo.Width, objBannerInfo.Height)

		End Sub


		Public Sub UpdateBanner(ByVal objBannerInfo As BannerInfo)

            DataProvider.Instance().UpdateBanner(objBannerInfo.BannerId, objBannerInfo.BannerName, objBannerInfo.ImageFile, objBannerInfo.URL, objBannerInfo.Impressions, objBannerInfo.CPM, objBannerInfo.StartDate, objBannerInfo.EndDate, objBannerInfo.CreatedByUser, objBannerInfo.BannerTypeId, objBannerInfo.Description, objBannerInfo.GroupName, objBannerInfo.Criteria, objBannerInfo.Width, objBannerInfo.Height)

		End Sub

		Public Function LoadBanners(ByVal PortalId As Integer, ByVal ModuleId As Integer, ByVal BannerTypeId As Integer, ByVal GroupName As String, ByVal Banners As Integer) As ArrayList

			Dim arrBanners As ArrayList
			Dim objBanner As BannerInfo
			Dim intCounter As Integer
			Dim datStartDate As Date
			Dim datEndDate As Date

			' get banners
			arrBanners = CBO.FillCollection(DataProvider.Instance().FindBanners(PortalId, BannerTypeId, GroupName), GetType(BannerInfo))

			' create collection
			LoadBanners = New ArrayList(Banners)

			If arrBanners.Count > 0 Then

				' get last index for rotation
				Dim intLastBannerIndex As Integer = 0
				Dim objLastBannerIndex As Object = DataCache.GetCache("LastBannerIndex:" & PortalId.ToString & ":" & ModuleId.ToString)
				If Not objLastBannerIndex Is Nothing Then
					intLastBannerIndex = Convert.ToInt32(objLastBannerIndex)
				End If

				If Banners > arrBanners.Count Then
					Banners = arrBanners.Count
				End If

				For intCounter = 1 To Banners
					intLastBannerIndex += 1
					If intLastBannerIndex > (arrBanners.Count - 1) Then
						intLastBannerIndex = 0
					End If

					objBanner = CType(arrBanners(intLastBannerIndex), BannerInfo)

					' add to collection
					LoadBanners.Add(objBanner)

					' update views
					If Null.IsNull(objBanner.StartDate) Then
						datStartDate = Now
					Else
						datStartDate = objBanner.StartDate
					End If
					If Null.IsNull(objBanner.EndDate) And objBanner.Views >= objBanner.Impressions And objBanner.Impressions <> 0 Then
						datEndDate = Now
					Else
						datEndDate = objBanner.EndDate
					End If
					DataProvider.Instance().UpdateBannerViews(objBanner.BannerId, datStartDate, datEndDate)

				Next

				' save last index for rotation
				DataCache.SetCache("LastBannerIndex:" & PortalId.ToString & ":" & ModuleId.ToString, intLastBannerIndex)

			End If

		End Function

		Public Sub UpdateBannerClickThrough(ByVal BannerId As Integer, ByVal VendorId As Integer)

			DataProvider.Instance().UpdateBannerClickThrough(BannerId, VendorId)

        End Sub

        Public Function FormatBanner(ByVal VendorId As Integer, ByVal BannerId As Integer, ByVal BannerTypeId As Integer, ByVal BannerName As String, ByVal ImageFile As String, ByVal Description As String, ByVal URL As String, ByVal Width As Integer, ByVal Height As Integer, ByVal BannerSource As String, ByVal HomeDirectory As String) As String

            Dim strBanner As String = ""

            Dim strURL As String = ""
            If BannerId <> -1 Then
                strURL = Common.Globals.ApplicationPath & "/LinkClick.aspx?BannerId=" & BannerId.ToString & "&VendorId=" & VendorId.ToString
            Else
                strURL = URL
            End If

            Select Case BannerTypeId
                Case BannerType.Text
                    strBanner += "<a href=""" & strURL & """ class=""NormalBold""><u>" & BannerName & "</u></a><br>"
                    strBanner += "<span class=""Normal"">" & Description & "</span><br>"
                    strBanner += "<a href=""" & strURL & """ class=""NormalRed"">" & URL & "</a>"
                Case BannerType.Script
                    strBanner += Description
                Case Else
                    If ImageFile.IndexOf("://") = -1 And ImageFile.StartsWith("/") = False Then
                        If ImageFile.ToLower.IndexOf(".swf") = -1 Then
                            strBanner += "<a href=""" & strURL & """>"
                            Select Case BannerSource
                                Case "L"       ' local
                                    strBanner += FormatImage(HomeDirectory & ImageFile, Width, Height, BannerName, Description)
                                Case "G"       ' global
                                    strBanner += FormatImage(Common.Globals.HostPath & ImageFile, Width, Height, BannerName, Description)
                            End Select
                            strBanner += "</a>"
                        Else ' flash
                            Select Case BannerSource
                                Case "L"       ' local
                                    strBanner += FormatFlash(HomeDirectory & ImageFile, Width, Height)
                                Case "G"       ' global
                                    strBanner += FormatFlash(Common.Globals.HostPath & ImageFile, Width, Height)
                            End Select
                        End If
                    Else
                        If ImageFile.ToLower.IndexOf(".swf") = -1 Then
                            strBanner += "<a href=""" & strURL & """>"
                            strBanner += FormatImage(ImageFile, Width, Height, BannerName, Description)
                            strBanner += "</a>"
                        Else ' flash
                            strBanner += FormatFlash(ImageFile, Width, Height)
                        End If
                    End If
            End Select

            Return strBanner

        End Function

        Private Function FormatImage(ByVal File As String, ByVal Width As Integer, ByVal Height As Integer, ByVal BannerName As String, ByVal Description As String) As String

            Dim Image As String = ""

            Image += "<img src=""" & File & """ border=""0"""
            If Description <> "" Then
                Image += " alt=""" & Description & """"
            Else
                Image += " alt=""" & BannerName & """"
            End If
            If Width > 0 Then
                Image += " width=""" & Width.ToString & """"
            End If
            If Height > 0 Then
                Image += " height=""" & Height.ToString & """"
            End If
            Image += """>"

            Return Image

        End Function

        Private Function FormatFlash(ByVal File As String, ByVal Width As Integer, ByVal Height As Integer) As String

            Dim Flash As String = ""

            Flash += "<object classid=""clsid:D27CDB6E-AE6D-11cf-96B8-444553540000"" codebase=""http://download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=4,0,2,0"" width=""" & Width.ToString & """ height=""" & Height.ToString & """>"
            Flash += "<param name=movie value=""" & File & """>"
            Flash += "<param name=quality value=high>"
            Flash += "<embed src=""" & File & """ quality=high pluginspage=""http://www.macromedia.com/shockwave/download/index.cgi?P1_Prod_Version=ShockwaveFlash"" type=""application/x-shockwave-flash"" width=""" & Width.ToString & """ height=""" & Height.ToString & """>"
            Flash += "</embed>"
            Flash += "</object>"

            Return Flash

        End Function

    End Class

End Namespace

