'
' DotNetNuke - http://www.dotnetnuke.com
' Copyright (c) 2002-2005
' by Perpetual Motion Interactive Systems Inc. ( http://www.perpetualmotion.ca )
'
' Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated 
' documentation files (the "Software"), to deal in the Software without restriction, including without limitation 
' the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and 
' to permit persons to whom the Software is furnished to do so, subject to the following conditions:
'
' The above copyright notice and this permission notice shall be included in all copies or substantial portions 
' of the Software.
'
' THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED 
' TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL 
' THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF 
' CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
' DEALINGS IN THE SOFTWARE.
'

Imports System
Imports System.Configuration
Imports System.Data

Namespace DotNetNuke.Services.Vendors

    Public Class VendorController

        Public Function GetVendors(Optional ByVal PortalId As Integer = -1, Optional ByVal Filter As String = "") As ArrayList
            Dim TotalRecords As Integer
            Return GetVendorsByName(Filter, PortalId, 0, 100000, TotalRecords)
        End Function
        Public Function GetVendors(ByVal PortalId As Integer, ByVal UnAuthorized As Boolean, ByVal PageIndex As Integer, ByVal PageSize As Integer, ByRef TotalRecords As Integer) As ArrayList
            Dim dr As IDataReader
            Try
                dr = DataProvider.Instance.GetVendors(PortalId, UnAuthorized, PageIndex, PageSize)
                While dr.Read
                    TotalRecords = Convert.ToInt32(dr("TotalRecords"))
                End While
                dr.NextResult()
                Return CBO.FillCollection(dr, GetType(VendorInfo))
            Finally
                If Not dr Is Nothing Then
                    dr.Close()
                End If
            End Try
        End Function
        Public Function GetVendorsByEmail(ByVal Filter As String, ByVal PortalId As Integer, ByVal Page As Integer, ByVal PageSize As Integer, ByRef TotalRecords As Integer) As ArrayList
            Dim dr As IDataReader
            Try
                dr = DataProvider.Instance.GetVendorsByEmail(Filter, PortalId, Page, PageSize)
                While dr.Read
                    TotalRecords = Convert.ToInt32(dr("TotalRecords"))
                End While
                dr.NextResult()
                Return CBO.FillCollection(dr, GetType(VendorInfo))
            Finally
                If Not dr Is Nothing Then
                    dr.Close()
                End If
            End Try
        End Function
        Public Function GetVendorsByName(ByVal Filter As String, ByVal PortalId As Integer, ByVal Page As Integer, ByVal PageSize As Integer, ByRef TotalRecords As Integer) As ArrayList
            Dim dr As IDataReader
            Try
                dr = DataProvider.Instance.GetVendorsByName(Filter, PortalId, Page, PageSize)
                While dr.Read
                    TotalRecords = Convert.ToInt32(dr("TotalRecords"))
                End While
                dr.NextResult()
                Return CBO.FillCollection(dr, GetType(VendorInfo))
            Finally
                If Not dr Is Nothing Then
                    dr.Close()
                End If
            End Try
        End Function
        Public Function GetVendor(ByVal VendorID As Integer, ByVal PortalId As Integer) As VendorInfo
            Return CType(CBO.FillObject(DataProvider.Instance().GetVendor(VendorID, PortalId), GetType(VendorInfo)), VendorInfo)
        End Function
        Public Sub DeleteVendor(ByVal VendorID As Integer)
            DataProvider.Instance().DeleteVendor(VendorID)
        End Sub
        Public Function AddVendor(ByVal objVendor As VendorInfo) As Integer
            Return DataProvider.Instance().AddVendor(objVendor.PortalId, objVendor.VendorName, objVendor.Unit, objVendor.Street, objVendor.City, objVendor.Region, objVendor.Country, objVendor.PostalCode, objVendor.Telephone, objVendor.Fax, objVendor.Cell, objVendor.Email, objVendor.Website, objVendor.FirstName, objVendor.LastName, objVendor.UserName, objVendor.LogoFile, objVendor.KeyWords, objVendor.Authorized.ToString)
        End Function
        Public Sub UpdateVendor(ByVal objVendor As VendorInfo)
            DataProvider.Instance().UpdateVendor(objVendor.VendorId, objVendor.VendorName, objVendor.Unit, objVendor.Street, objVendor.City, objVendor.Region, objVendor.Country, objVendor.PostalCode, objVendor.Telephone, objVendor.Fax, objVendor.Cell, objVendor.Email, objVendor.Website, objVendor.FirstName, objVendor.LastName, objVendor.UserName, objVendor.LogoFile, objVendor.KeyWords, objVendor.Authorized.ToString)
        End Sub

        Public Sub DeleteVendors(Optional ByVal PortalID As Integer = -1)

            Dim dr As IDataReader = DataProvider.Instance().GetVendors(PortalID, True, Null.NullInteger, Null.NullInteger)
            If Not dr Is Nothing Then dr.NextResult()
            While dr.Read
                If DateDiff(DateInterval.Day, Convert.ToDateTime(dr("CreatedDate")), Now()) > 7 Then
                    DataProvider.Instance().DeleteVendor(Convert.ToInt32(dr("VendorID")))
                End If
            End While
            dr.Close()

        End Sub

        Public Function FindVendors(ByVal DisplayPortalId As Integer, ByVal search As String, Optional ByVal SelectPortalId As Integer = -1) As ArrayList

        End Function
    End Class

End Namespace

