'
' DotNetNuke - http://www.dotnetnuke.com
' Copyright (c) 2002-2005
' by Perpetual Motion Interactive Systems Inc. ( http://www.perpetualmotion.ca )
'
' Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated 
' documentation files (the "Software"), to deal in the Software without restriction, including without limitation 
' the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and 
' to permit persons to whom the Software is furnished to do so, subject to the following conditions:
'
' The above copyright notice and this permission notice shall be included in all copies or substantial portions 
' of the Software.
'
' THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED 
' TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL 
' THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF 
' CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
' DEALINGS IN THE SOFTWARE.
'

Namespace DotNetNuke.Services.Wizards

	''' -----------------------------------------------------------------------------
	''' <summary>
	''' The WizardCancelEventArgs class extends WizardEventArgs to provide a Cancel
	'''	Property for the Event
	'''	Properties.
	''' </summary>
	''' <returns></returns>
	''' <remarks>
	''' </remarks>
	''' <history>
	''' 	[cnurse]	10/11/2004	created
	''' </history>
	''' -----------------------------------------------------------------------------
	Public Class WizardCancelEventArgs
		Inherits WizardEventArgs

#Region "Private Members"

		Private m_Cancel As Boolean = False

#End Region

#Region "Constructors"

		''' -----------------------------------------------------------------------------
		''' <summary>
		''' Constructs a default WizardEventArgs object
		''' </summary>
		''' <returns></returns>
		''' <remarks>
		''' </remarks>
		''' <history>
		''' 	[cnurse]	10/10/2004	created
		''' </history>
		''' -----------------------------------------------------------------------------
		Public Sub New()
			Me.New(-1, -1, Nothing)
		End Sub

		''' -----------------------------------------------------------------------------
		''' <summary>
		''' Constructs a custom WizardEventArgs object
		''' </summary>
		''' <returns></returns>
		''' <remarks>
		''' </remarks>
		''	<param name="pageNo">The Page No where the Event happened</param>
		''	<param name="pages">The WizardPageCollection</param>
		''' <history>
		''' 	[cnurse]	10/10/2004	created
		''' </history>
		''' -----------------------------------------------------------------------------
		Public Sub New(ByVal pageNo As Integer, ByVal pages As WizardPageCollection)
			MyBase.New(pageNo, pages)
			Me.Cancel = False
		End Sub

		''' -----------------------------------------------------------------------------
		''' <summary>
		''' Constructs a custom WizardEventArgs object
		''' </summary>
		''' <returns></returns>
		''' <remarks>
		''' </remarks>
		''	<param name="pageNo">The Page No where the Event happened</param>
		''	<param name="prevNo">The Page No where the Event happened</param>
		''	<param name="pages">The WizardPageCollection</param>
		''' <history>
		''' 	[cnurse]	10/10/2004	created
		''' </history>
		''' -----------------------------------------------------------------------------
		Public Sub New(ByVal pageNo As Integer, ByVal prevNo As Integer, ByVal pages As WizardPageCollection)
			MyBase.New(pageNo, prevNo, pages)
			Me.Cancel = False
		End Sub

#End Region

#Region "Properties"

		Public Property Cancel() As Boolean
			Get
				Return m_Cancel
			End Get
			Set(ByVal Value As Boolean)
				m_Cancel = Value
			End Set
		End Property

#End Region

	End Class

End Namespace
