'
' DotNetNuke - http://www.dotnetnuke.com
' Copyright (c) 2002-2005
' by Perpetual Motion Interactive Systems Inc. ( http://www.perpetualmotion.ca )
'
' Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated 
' documentation files (the "Software"), to deal in the Software without restriction, including without limitation 
' the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and 
' to permit persons to whom the Software is furnished to do so, subject to the following conditions:
'
' The above copyright notice and this permission notice shall be included in all copies or substantial portions 
' of the Software.
'
' THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED 
' TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL 
' THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF 
' CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
' DEALINGS IN THE SOFTWARE.
'

Imports DotNetNuke.Entities.Modules
Imports DotNetNuke.Entities.Modules.Definitions


Namespace DotNetNuke.UI.ControlPanels

	''' -----------------------------------------------------------------------------
	''' <summary>
	''' The Classic ControlPanel provides athe Classic Page/Module manager
	''' </summary>
	''' <returns></returns>
	''' <remarks>
	''' </remarks>
	''' <history>
	''' 	[cnurse]	10/06/2004	Updated to reflect design changes for Help, 508 support
	'''                       and localisation
	''' </history>
	''' -----------------------------------------------------------------------------
    Public MustInherit Class Classic

        Inherits ControlPanelBase

#Region "Controls"

        Protected WithEvents cmdAddTab As System.Web.UI.WebControls.HyperLink
        Protected WithEvents cmdEditTab As System.Web.UI.WebControls.HyperLink
        Protected WithEvents cmdCopyTab As System.Web.UI.WebControls.HyperLink
        Protected WithEvents cmdHelpShow As System.Web.UI.WebControls.ImageButton
        Protected WithEvents cmdHelpHide As System.Web.UI.WebControls.ImageButton
        Protected WithEvents cboDesktopModules As System.Web.UI.WebControls.DropDownList
        Protected WithEvents cboPanes As System.Web.UI.WebControls.DropDownList
        Protected WithEvents cboAlign As System.Web.UI.WebControls.DropDownList
        Protected WithEvents cmdAdd As System.Web.UI.WebControls.LinkButton
        Protected WithEvents chkContent As System.Web.UI.WebControls.CheckBox
        Protected WithEvents chkPreview As System.Web.UI.WebControls.CheckBox
        Protected WithEvents lblDescription As System.Web.UI.WebControls.Label
        Protected WithEvents lblAdmin As System.Web.UI.WebControls.Label
        Protected WithEvents lblModule As System.Web.UI.WebControls.Label
        Protected WithEvents lblPane As System.Web.UI.WebControls.Label
        Protected WithEvents lblAlign As System.Web.UI.WebControls.Label

#End Region

#Region "Event Handlers"

        ''' -----------------------------------------------------------------------------
        ''' <summary>
        ''' Page_Load runs when the control is loaded.
        ''' </summary>
        ''' <returns></returns>
        ''' <remarks>
        ''' </remarks>
        ''' <history>
        ''' 	[cnurse]	10/06/2004	Updated to reflect design changes for Help, 508 support
        '''                       and localisation
        ''' </history>
        ''' -----------------------------------------------------------------------------
        Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
            Try

                If Not Page.IsPostBack Then
                    'Localization
                    lblAdmin.Text = Services.Localization.Localization.GetString("Admin", Me.LocalResourceFile)
                    cmdAddTab.Text = Services.Localization.Localization.GetString("AddTab", Me.LocalResourceFile)
                    cmdAddTab.ToolTip = Services.Localization.Localization.GetString("AddTab.ToolTip", Me.LocalResourceFile)
                    cmdEditTab.Text = Services.Localization.Localization.GetString("EditTab", Me.LocalResourceFile)
                    cmdEditTab.ToolTip = Services.Localization.Localization.GetString("EditTab.ToolTip", Me.LocalResourceFile)
                    cmdCopyTab.Text = Services.Localization.Localization.GetString("CopyTab", Me.LocalResourceFile)
                    cmdCopyTab.ToolTip = Services.Localization.Localization.GetString("CopyTab.ToolTip", Me.LocalResourceFile)
                    cmdHelpShow.AlternateText = Services.Localization.Localization.GetString("ShowHelp.AlternateText", Me.LocalResourceFile)
                    cmdHelpHide.AlternateText = Services.Localization.Localization.GetString("HideHelp.AlternateText", Me.LocalResourceFile)
                    lblModule.Text = Services.Localization.Localization.GetString("Module", Me.LocalResourceFile)
                    lblPane.Text = Services.Localization.Localization.GetString("Pane", Me.LocalResourceFile)
                    lblAlign.Text = Services.Localization.Localization.GetString("Align", Me.LocalResourceFile)
                    cmdAdd.Text = Services.Localization.Localization.GetString("AddModule", Me.LocalResourceFile)
                    cmdAdd.ToolTip = Services.Localization.Localization.GetString("AddModule.ToolTip", Me.LocalResourceFile)
                    chkContent.Text = Services.Localization.Localization.GetString("Content.Text", Me.LocalResourceFile)
                    chkPreview.Text = Services.Localization.Localization.GetString("Preview.Text", Me.LocalResourceFile)
                    chkContent.ToolTip = Services.Localization.Localization.GetString("Content.ToolTip", Me.LocalResourceFile)
                    chkPreview.ToolTip = Services.Localization.Localization.GetString("Preview.ToolTip", Me.LocalResourceFile)

                    cmdAddTab.NavigateUrl = NavigateURL("Tab")
                    If Not PortalSettings.ActiveTab.IsAdminTab Then
                        cmdEditTab.NavigateUrl = NavigateURL(PortalSettings.ActiveTab.TabID, "Tab", "action=edit")
                        cmdCopyTab.NavigateUrl = NavigateURL(PortalSettings.ActiveTab.TabID, "Tab", "action=copy")
                    Else
                        cmdEditTab.Visible = False
                        cmdCopyTab.Visible = False
                    End If

                    cmdHelpShow.ImageUrl = "~/images/help.gif"
                    cmdHelpShow.Visible = True

                    cmdHelpHide.ImageUrl = "~/images/cancel.gif"
                    cmdHelpHide.Visible = False

                    Dim objDesktopModules As New DesktopModuleController
                    cboDesktopModules.DataSource = objDesktopModules.GetDesktopModulesByPortal(PortalSettings.PortalId)
                    cboDesktopModules.DataBind()

                    Dim intItem As Integer
                    For intItem = 0 To PortalSettings.ActiveTab.Panes.Count - 1
                        cboPanes.Items.Add(Convert.ToString(PortalSettings.ActiveTab.Panes(intItem)))
                    Next intItem
                    cboPanes.Items.FindByValue(glbDefaultPane).Selected = True

                    If cboAlign.Items.Count > 0 Then
                        cboAlign.SelectedIndex = 0
                    End If

                    chkContent.Checked = True
                    If Not Request.Cookies("_Tab_Admin_Content" & PortalSettings.PortalId.ToString) Is Nothing Then
                        chkContent.Checked = Boolean.Parse(Request.Cookies("_Tab_Admin_Content" & PortalSettings.PortalId.ToString).Value)
                    End If

                    chkPreview.Checked = False
                    If Not Request.Cookies("_Tab_Admin_Preview" & PortalSettings.PortalId.ToString) Is Nothing Then
                        chkPreview.Checked = Boolean.Parse(Request.Cookies("_Tab_Admin_Preview" & PortalSettings.PortalId.ToString).Value)
                    End If

                End If

            Catch exc As Exception    'Module failed to load
                ProcessModuleLoadException(Me, exc)
            End Try
        End Sub

        ''' -----------------------------------------------------------------------------
        ''' <summary>
        ''' cmdAdd_Click runs when the Add Button is clicked
        ''' </summary>
        ''' <returns></returns>
        ''' <remarks>
        ''' </remarks>
        ''' <history>
        ''' 	[cnurse]	10/06/2004	Updated to reflect design changes for Help, 508 support
        '''                       and localisation
        '''     [vmasanas]  01/07/2005  Modified to add view perm. to all roles with edit perm.
        ''' </history>
        ''' -----------------------------------------------------------------------------
        Private Sub cmdAdd_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmdAdd.Click
            Try

                Dim objTabPermissions As Security.Permissions.TabPermissionCollection
                objTabPermissions = PortalSettings.ActiveTab.TabPermissions

                Dim UserId As Integer = -1
                If Request.IsAuthenticated Then

                    Dim objUserInfo As UserInfo = UserController.GetCurrentUserInfo
                    UserId = objUserInfo.UserID
                End If

                Dim objPermissionController As New Security.Permissions.PermissionController

                ' save to database
                Dim objModuleDefinitions As New ModuleDefinitionController
                Dim objModuleDefinition As ModuleDefinitionInfo
                Dim objEventLog As New Services.Log.EventLog.EventLogController
                Dim objRoles As New Security.Roles.RoleController
                Dim objRole As Security.Roles.RoleInfo

                Dim intIndex As Integer
                Dim arrModuleDefinitions As ArrayList = objModuleDefinitions.GetModuleDefinitions(Integer.Parse(cboDesktopModules.SelectedItem.Value))
                For intIndex = 0 To arrModuleDefinitions.Count - 1
                    objModuleDefinition = CType(arrModuleDefinitions(intIndex), ModuleDefinitionInfo)

                    Dim objModule As New ModuleInfo
                    objModule.Initialize(PortalSettings.PortalId)

                    objModule.PortalID = PortalSettings.PortalId
                    objModule.TabID = PortalSettings.ActiveTab.TabID
                    objModule.ModuleOrder = -1
                    objModule.ModuleTitle = objModuleDefinition.FriendlyName
                    objModule.PaneName = cboPanes.SelectedItem.Text
                    objModule.ModuleDefID = objModuleDefinition.ModuleDefID
                    objModule.CacheTime = objModuleDefinition.DefaultCacheTime

                    Dim arrSystemModuleViewPermissions As ArrayList = objPermissionController.GetPermissionByCodeAndKey("SYSTEM_MODULE_DEFINITION", "VIEW")

                    Dim objModulePermissions As New Security.Permissions.ModulePermissionCollection
                    Dim objTabPermission As Security.Permissions.TabPermissionInfo
                    For Each objTabPermission In objTabPermissions
                        Dim arrSystemModulePermissions As ArrayList = objPermissionController.GetPermissionByCodeAndKey("SYSTEM_MODULE_DEFINITION", objTabPermission.PermissionKey)
                        Dim j As Integer
                        For j = 0 To arrSystemModulePermissions.Count - 1
                            Dim objModulePermission As New Security.Permissions.ModulePermissionInfo
                            Dim objSystemModulePermission As Security.Permissions.PermissionInfo
                            objSystemModulePermission = CType(arrSystemModulePermissions(j), Security.Permissions.PermissionInfo)
                            objModulePermission.ModuleID = objModule.ModuleID
                            objModulePermission.PermissionID = objSystemModulePermission.PermissionID
                            objModulePermission.RoleID = objTabPermission.RoleID
                            objModulePermission.PermissionKey = objSystemModulePermission.PermissionKey
                            objModulePermission.AllowAccess = False

                            ' get the role name
                            objRole = objRoles.GetRole(objModulePermission.RoleID, PortalSettings.PortalId)
                            If Not objRole Is Nothing Then
                                ' if the role is in the list of administrator roles for the Tab
                                If PortalSettings.ActiveTab.AdministratorRoles.IndexOf(objRole.RoleName) <> -1 Then
                                    ' allow access ( view/edit )
                                    objModulePermission.AllowAccess = True
                                End If
                            End If

                            If Not objModulePermissions.Contains(objModulePermission) And objModulePermission.AllowAccess Then
                                objModulePermissions.Add(objModulePermission)
                            End If

                            If objModulePermission.PermissionKey = "EDIT" And objModulePermission.AllowAccess Then
                                'if edit => view also
                                Dim objModuleViewperm As New Security.Permissions.ModulePermissionInfo
                                objModuleViewperm.ModuleID = objModulePermission.ModuleID
                                objModuleViewperm.PermissionID = CType(arrSystemModuleViewPermissions(0), Security.Permissions.PermissionInfo).PermissionID
                                objModuleViewperm.RoleID = objModulePermission.RoleID
                                objModuleViewperm.PermissionKey = "VIEW"
                                objModuleViewperm.AllowAccess = True
                                If Not objModulePermissions.Contains(objModuleViewperm) Then
                                    objModulePermissions.Add(objModuleViewperm)
                                End If
                            End If
                        Next
                    Next

                    objModule.ModulePermissions = objModulePermissions
                    objModule.AllTabs = False
                    objModule.Visibility = VisibilityState.Maximized
                    objModule.Alignment = cboAlign.SelectedItem.Value

                    Dim objModules As New ModuleController
                    objModules.AddModule(objModule)
					objEventLog.AddLog(objModule, PortalSettings, UserId, "", Services.Log.EventLog.EventLogController.EventLogType.MODULE_CREATED)
                Next

                ' Redirect to the same page to pick up changes
                Response.Redirect(Request.RawUrl, True)

            Catch exc As Exception    'Module failed to load
                ProcessModuleLoadException(Me, exc)
            End Try
        End Sub

        ''' -----------------------------------------------------------------------------
        ''' <summary>
        ''' chkContent_CheckedChanged runs when the Content check box is changed
        ''' </summary>
        ''' <returns></returns>
        ''' <remarks>
        ''' </remarks>
        ''' <history>
        ''' 	[cnurse]	10/06/2004	Updated to reflect design changes for Help, 508 support
        '''                       and localisation
        ''' </history>
        ''' -----------------------------------------------------------------------------
        Private Sub chkContent_CheckedChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles chkContent.CheckedChanged
            Try

                Dim objContent As HttpCookie

                If Request.Cookies("_Tab_Admin_Content" & PortalSettings.PortalId.ToString) Is Nothing Then
                    objContent = New HttpCookie("_Tab_Admin_Content" & PortalSettings.PortalId.ToString)
                    objContent.Expires = DateTime.MaxValue       ' never expires
                    Response.AppendCookie(objContent)
                End If

                objContent = Request.Cookies("_Tab_Admin_Content" & PortalSettings.PortalId.ToString)
                objContent.Value = chkContent.Checked.ToString
                Response.SetCookie(objContent)

                Response.Redirect(Request.RawUrl, True)

            Catch exc As Exception    'Module failed to load
                ProcessModuleLoadException(Me, exc)
            End Try
        End Sub

        ''' -----------------------------------------------------------------------------
        ''' <summary>
        ''' chkPreview_CheckedChanged runs when the Preview check box is changed
        ''' </summary>
        ''' <returns></returns>
        ''' <remarks>
        ''' </remarks>
        ''' <history>
        ''' 	[cnurse]	10/06/2004	Updated to reflect design changes for Help, 508 support
        '''                       and localisation
        ''' </history>
        ''' -----------------------------------------------------------------------------
        Private Sub chkPreview_CheckedChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles chkPreview.CheckedChanged
            Try

                Dim objPreview As HttpCookie

                If Request.Cookies("_Tab_Admin_Preview" & PortalSettings.PortalId.ToString) Is Nothing Then
                    objPreview = New HttpCookie("_Tab_Admin_Preview" & PortalSettings.PortalId.ToString)
                    Response.AppendCookie(objPreview)
                End If

                objPreview = Request.Cookies("_Tab_Admin_Preview" & PortalSettings.PortalId.ToString)
                objPreview.Value = chkPreview.Checked.ToString
                Response.SetCookie(objPreview)

                Response.Redirect(Request.RawUrl, True)

            Catch exc As Exception    'Module failed to load
                ProcessModuleLoadException(Me, exc)
            End Try
        End Sub

        ''' -----------------------------------------------------------------------------
        ''' <summary>
        ''' cmdHelpHide_Click runs when the Hide Help Button is clicked
        ''' </summary>
        ''' <returns></returns>
        ''' <remarks>
        ''' </remarks>
        ''' <history>
        ''' 	[cnurse]	10/06/2004	Updated to reflect design changes for Help, 508 support
        '''                       and localisation
        ''' </history>
        ''' -----------------------------------------------------------------------------
        Private Sub cmdHelpHide_Click(ByVal sender As Object, ByVal e As System.Web.UI.ImageClickEventArgs) Handles cmdHelpHide.Click
            Try
                lblDescription.Text = ""

                cmdHelpShow.Visible = True
                cmdHelpHide.Visible = False

            Catch exc As Exception    'Module failed to load
                ProcessModuleLoadException(Me, exc)
            End Try
        End Sub

        ''' -----------------------------------------------------------------------------
        ''' <summary>
        ''' cmdHelpShow_Click runs when the Hide Help Button is clicked
        ''' </summary>
        ''' <returns></returns>
        ''' <remarks>
        ''' </remarks>
        ''' <history>
        ''' 	[cnurse]	10/06/2004	Updated to reflect design changes for Help, 508 support
        '''                       and localisation
        ''' </history>
        ''' -----------------------------------------------------------------------------
        Private Sub cmdHelpShow_Click(ByVal sender As Object, ByVal e As System.Web.UI.ImageClickEventArgs) Handles cmdHelpShow.Click
            Try
                Dim objDesktopModules As New DesktopModuleController
                Dim objDesktopModule As DesktopModuleInfo

                objDesktopModule = objDesktopModules.GetDesktopModule(Int32.Parse(cboDesktopModules.SelectedItem.Value))
                If Not objDesktopModule Is Nothing Then
                    lblDescription.Text = "<br>" & objDesktopModule.Description & "<br>"
                End If

                cmdHelpShow.Visible = False
                cmdHelpHide.Visible = True

            Catch exc As Exception    'Module failed to load
                ProcessModuleLoadException(Me, exc)
            End Try
        End Sub

#End Region

#Region " Web Form Designer Generated Code "


        <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

        End Sub

        Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
            'CODEGEN: This method call is required by the Web Form Designer
            'Do not modify it using the code editor.
            InitializeComponent()

            Me.ID = "Classic.ascx"

        End Sub

#End Region

    End Class

End Namespace
