'
' DotNetNuke - http://www.dotnetnuke.com
' Copyright (c) 2002-2005
' by Perpetual Motion Interactive Systems Inc. ( http://www.perpetualmotion.ca )
'
' Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated 
' documentation files (the "Software"), to deal in the Software without restriction, including without limitation 
' the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and 
' to permit persons to whom the Software is furnished to do so, subject to the following conditions:
'
' The above copyright notice and this permission notice shall be included in all copies or substantial portions 
' of the Software.
'
' THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED 
' TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL 
' THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF 
' CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
' DEALINGS IN THE SOFTWARE.
'

Imports System.IO
Imports System.Runtime.Serialization.Formatters
Imports System.Net
Imports DotNetNuke.Entities.Modules
Imports DotNetNuke.UI.Skins
Imports DotNetNuke.Framework.Providers
Imports DotNetNuke.Modules.Admin.FileSystem


Namespace DotNetNuke.Modules.Admin.Host

    ''' -----------------------------------------------------------------------------
    ''' <summary>
    ''' The HostSettingsModule PortalModuleBase is used to edit the host settings
    ''' for the application.
    ''' </summary>
    ''' <returns></returns>
    ''' <remarks>
    ''' </remarks>
    ''' <history>
    ''' 	[cnurse]	9/27/2004	Updated to reflect design changes for Help, 508 support
    '''                       and localisation
    ''' </history>
    ''' -----------------------------------------------------------------------------
    Public MustInherit Class HostSettingsModule
        Inherits DotNetNuke.Entities.Modules.PortalModuleBase

#Region "Controls"

        'Basic Settings Section
        Protected dshBasic As UI.UserControls.SectionHeadControl
        Protected tblBasic As System.Web.UI.HtmlControls.HtmlTable
        Protected lblBasicSettingsHelp As System.Web.UI.WebControls.Label

        'Configuration Section
        Protected dshConfiguration As UI.UserControls.SectionHeadControl
        Protected tblConfiguration As System.Web.UI.HtmlControls.HtmlTable
        Protected plVersion As UI.UserControls.LabelControl
        Protected lblVersion As System.Web.UI.WebControls.Label
        Protected plDataProvider As UI.UserControls.LabelControl
        Protected lblDataProvider As System.Web.UI.WebControls.Label
        Protected plFrameowrk As UI.UserControls.LabelControl
        Protected lblFramework As System.Web.UI.WebControls.Label
        Protected plIdentity As UI.UserControls.LabelControl
        Protected lblIdentity As System.Web.UI.WebControls.Label
        Protected plHostName As UI.UserControls.LabelControl
        Protected lblHostName As System.Web.UI.WebControls.Label

        'Host Section
        Protected dshHost As UI.UserControls.SectionHeadControl
        Protected tblHost As System.Web.UI.HtmlControls.HtmlTable
        Protected plHostPortal As UI.UserControls.LabelControl
        Protected cboHostPortal As System.Web.UI.WebControls.DropDownList
        Protected plHostTitle As UI.UserControls.LabelControl
        Protected txtHostTitle As System.Web.UI.WebControls.TextBox
        Protected plHostURL As UI.UserControls.LabelControl
        Protected txtHostURL As System.Web.UI.WebControls.TextBox
        Protected plHostEmail As UI.UserControls.LabelControl
        Protected txtHostEmail As System.Web.UI.WebControls.TextBox

        'Appearance Section
        Protected dshAppearance As UI.UserControls.SectionHeadControl
        Protected tblAppearance As System.Web.UI.HtmlControls.HtmlTable
        Protected plHostSkin As UI.UserControls.LabelControl
        Protected ctlHostSkin As UI.Skins.SkinControl
        Protected plHostContainer As UI.UserControls.LabelControl
        Protected ctlHostContainer As UI.Skins.SkinControl
        Protected plAdminSkin As UI.UserControls.LabelControl
        Protected ctlAdminSkin As UI.Skins.SkinControl
        Protected plAdminContainer As UI.UserControls.LabelControl
        Protected ctlAdminContainer As UI.Skins.SkinControl
        Protected plCopyright As UI.UserControls.LabelControl
        Protected chkCopyright As System.Web.UI.WebControls.CheckBox
        Protected plUseCustomErrorMessages As UI.UserControls.LabelControl
        Protected chkUseCustomErrorMessages As System.Web.UI.WebControls.CheckBox

        'Payment Section
        Protected dshPayment As UI.UserControls.SectionHeadControl
        Protected tblPayment As System.Web.UI.HtmlControls.HtmlTable
        Protected plProcessor As UI.UserControls.LabelControl
        Protected cboProcessor As System.Web.UI.WebControls.DropDownList
        Protected WithEvents cmdProcessor As System.Web.UI.WebControls.LinkButton
        Protected plUserId As UI.UserControls.LabelControl
        Protected txtUserId As System.Web.UI.WebControls.TextBox
        Protected plPassword As UI.UserControls.LabelControl
        Protected txtPassword As System.Web.UI.WebControls.TextBox
        Protected plHostFee As UI.UserControls.LabelControl
        Protected txtHostFee As System.Web.UI.WebControls.TextBox
        Protected plHostCurrency As UI.UserControls.LabelControl
        Protected cboHostCurrency As System.Web.UI.WebControls.DropDownList
        Protected plHostSpace As UI.UserControls.LabelControl
        Protected txtHostSpace As System.Web.UI.WebControls.TextBox
        Protected plDemoPeriod As UI.UserControls.LabelControl
        Protected txtDemoPeriod As System.Web.UI.WebControls.TextBox
        Protected plDemoSignup As UI.UserControls.LabelControl
        Protected chkDemoSignup As System.Web.UI.WebControls.CheckBox

        'Advanced Settings Section
        Protected dshAdvanced As UI.UserControls.SectionHeadControl
        Protected tblAdvanced As System.Web.UI.HtmlControls.HtmlTable
        Protected lblAdvancedSettingsHelp As System.Web.UI.WebControls.Label

        'Proxy Section
        Protected dshProxy As UI.UserControls.SectionHeadControl
        Protected tblProxy As System.Web.UI.HtmlControls.HtmlTable
        Protected plProxyServer As UI.UserControls.LabelControl
        Protected txtProxyServer As System.Web.UI.WebControls.TextBox
        Protected plProxyPort As UI.UserControls.LabelControl
        Protected txtProxyPort As System.Web.UI.WebControls.TextBox
        Protected plProxyUsername As UI.UserControls.LabelControl
        Protected txtProxyUsername As System.Web.UI.WebControls.TextBox
        Protected plProxyPassword As UI.UserControls.LabelControl
        Protected txtProxyPassword As System.Web.UI.WebControls.TextBox
        Protected plWebRequestTimeout As UI.UserControls.LabelControl
        Protected txtWebRequestTimeout As System.Web.UI.WebControls.TextBox

        'SMTP Section
        Protected dshSMTP As UI.UserControls.SectionHeadControl
        Protected tblSMTP As System.Web.UI.HtmlControls.HtmlTable
        Protected plSMTPServer As UI.UserControls.LabelControl
        Protected txtSMTPServer As System.Web.UI.WebControls.TextBox
        Protected plSMTPAuthentication As UI.UserControls.LabelControl
        Protected optSMTPAuthentication As System.Web.UI.WebControls.RadioButtonList
        Protected plSMTPUsername As UI.UserControls.LabelControl
        Protected txtSMTPUsername As System.Web.UI.WebControls.TextBox
        Protected plSMTPPassword As UI.UserControls.LabelControl
        Protected txtSMTPPassword As System.Web.UI.WebControls.TextBox
        Protected WithEvents cmdEmail As System.Web.UI.WebControls.LinkButton
        Protected lblEmail As System.Web.UI.WebControls.Label

        'Other Section
        Protected dshOther As UI.UserControls.SectionHeadControl
        Protected tblOther As System.Web.UI.HtmlControls.HtmlTable
        Protected plControlPanel As UI.UserControls.LabelControl
        Protected cboControlPanel As System.Web.UI.WebControls.DropDownList
        Protected plSiteLogStorage As UI.UserControls.LabelControl
        Protected optSiteLogStorage As System.Web.UI.WebControls.RadioButtonList
        Protected plSiteLogBuffer As UI.UserControls.LabelControl
        Protected txtSiteLogBuffer As System.Web.UI.WebControls.TextBox
        Protected plSiteLogHistory As UI.UserControls.LabelControl
        Protected txtSiteLogHistory As System.Web.UI.WebControls.TextBox
        Protected plFileExtensions As UI.UserControls.LabelControl
        Protected txtFileExtensions As System.Web.UI.WebControls.TextBox
        Protected plSkinUpload As UI.UserControls.LabelControl
        Protected optSkinUpload As System.Web.UI.WebControls.RadioButtonList
        Protected plUsersOnlineTime As UI.UserControls.LabelControl
        Protected txtUsersOnlineTime As System.Web.UI.WebControls.TextBox
        Protected plUsersOnline As UI.UserControls.LabelControl
        Protected chkUsersOnline As System.Web.UI.WebControls.CheckBox
        Protected plUseFriendlyUrls As UI.UserControls.LabelControl
        Protected chkUseFriendlyUrls As System.Web.UI.WebControls.CheckBox
        Protected plPerformance As UI.UserControls.LabelControl
        Protected WithEvents cboPerformance As System.Web.UI.WebControls.DropDownList
        Protected WithEvents cmdCache As System.Web.UI.WebControls.LinkButton
        Protected WithEvents cmdUpdate As System.Web.UI.WebControls.LinkButton
        Protected cboUpgrade As System.Web.UI.WebControls.DropDownList
        Protected WithEvents cmdUpgrade As System.Web.UI.WebControls.LinkButton
        Protected lblUpgrade As System.Web.UI.WebControls.Label
        Protected WithEvents lnkUploadSkin As System.Web.UI.WebControls.HyperLink
        Protected WithEvents lnkUploadContainer As System.Web.UI.WebControls.HyperLink
        Protected WithEvents cboSchedulerMode As System.Web.UI.WebControls.DropDownList
        Protected lblLog As System.Web.UI.WebControls.Label
        Protected plLogBuffer As UI.UserControls.LabelControl
        Protected WithEvents txtAutoAccountUnlock As System.Web.UI.WebControls.TextBox
        Protected WithEvents cboCacheMethod As System.Web.UI.WebControls.RadioButtonList
        Protected WithEvents txtHelpURL As System.Web.UI.WebControls.TextBox
        Protected WithEvents chkEnableHelp As System.Web.UI.WebControls.CheckBox
        Protected chkLogBuffer As System.Web.UI.WebControls.CheckBox


#End Region

#Region "Private Methods"

        ''' -----------------------------------------------------------------------------
        ''' <summary>
        ''' BindData fetches the data from the database and updates the controls
        ''' </summary>
        ''' <returns></returns>
        ''' <remarks>
        ''' </remarks>
        ''' <history>
        ''' 	[cnurse]	9/27/2004	Updated to reflect design changes for Help, 508 support
        '''                       and localisation
        ''' </history>
        ''' -----------------------------------------------------------------------------
        Private Sub BindData()

            lblVersion.Text = PortalSettings.Version
            lblDataProvider.Text = ProviderConfiguration.GetProviderConfiguration("data").DefaultProvider
            lblFramework.Text = System.Environment.Version.ToString
            lblIdentity.Text = System.Security.Principal.WindowsIdentity.GetCurrent.Name
            lblHostName.Text = Dns.GetHostName()

            Dim objPortals As New PortalController
            cboHostPortal.DataSource = objPortals.GetPortals
            cboHostPortal.DataBind()
            If Convert.ToString(Common.Globals.HostSettings("HostPortalId")) <> "" Then
                If Not cboHostPortal.Items.FindByValue(Convert.ToString(Common.Globals.HostSettings("HostPortalId"))) Is Nothing Then
                    cboHostPortal.Items.FindByValue(Convert.ToString(Common.Globals.HostSettings("HostPortalId"))).Selected = True
                End If
            End If
            txtHostTitle.Text = Convert.ToString(Common.Globals.HostSettings("HostTitle"))
            txtHostURL.Text = Convert.ToString(Common.Globals.HostSettings("HostURL"))
            txtHostEmail.Text = Convert.ToString(Common.Globals.HostSettings("HostEmail"))

            Dim objSkins As New UI.Skins.SkinController
            Dim objSkin As UI.Skins.SkinInfo

            ctlHostSkin.Width = "252px"
            ctlHostSkin.SkinRoot = SkinInfo.RootSkin
            objSkin = objSkins.GetSkin(SkinInfo.RootSkin, Null.NullInteger, SkinType.Portal)
            If Not objSkin Is Nothing Then
                If Null.IsNull(objSkin.PortalId) = True Then
                    ctlHostSkin.SkinSrc = objSkin.SkinSrc
                End If
            End If
            ctlHostContainer.Width = "252px"
            ctlHostContainer.SkinRoot = SkinInfo.RootContainer
            objSkin = objSkins.GetSkin(SkinInfo.RootContainer, Null.NullInteger, SkinType.Portal)
            If Not objSkin Is Nothing Then
                If Null.IsNull(objSkin.PortalId) = True Then
                    ctlHostContainer.SkinSrc = objSkin.SkinSrc
                End If
            End If

            ctlAdminSkin.Width = "252px"
            ctlAdminSkin.SkinRoot = SkinInfo.RootSkin
            objSkin = objSkins.GetSkin(SkinInfo.RootSkin, Null.NullInteger, SkinType.Admin)
            If Not objSkin Is Nothing Then
                If Null.IsNull(objSkin.PortalId) = True Then
                    ctlAdminSkin.SkinSrc = objSkin.SkinSrc
                End If
            End If
            ctlAdminContainer.Width = "252px"
            ctlAdminContainer.SkinRoot = SkinInfo.RootContainer
            objSkin = objSkins.GetSkin(SkinInfo.RootContainer, Null.NullInteger, SkinType.Admin)
            If Not objSkin Is Nothing Then
                If Null.IsNull(objSkin.PortalId) = True Then
                    ctlAdminContainer.SkinSrc = objSkin.SkinSrc
                End If
            End If
            Dim objModuleControls As New ModuleControlController
            Dim arrModuleControls As ArrayList = objModuleControls.GetModuleControls(Null.NullInteger)
            Dim objModuleControl As ModuleControlInfo
            Dim intModuleControl As Integer
            For intModuleControl = 0 To arrModuleControls.Count - 1
                objModuleControl = DirectCast(arrModuleControls(intModuleControl), ModuleControlInfo)
                If objModuleControl.ControlType = SecurityAccessLevel.ControlPanel Then
                    cboControlPanel.Items.Add(New ListItem(objModuleControl.ControlKey.Replace("CONTROLPANEL:", ""), objModuleControl.ControlSrc))
                End If
            Next intModuleControl
            If Convert.ToString(Common.Globals.HostSettings("ControlPanel")) <> "" Then
                If Not cboControlPanel.Items.FindByValue(Convert.ToString(Common.Globals.HostSettings("ControlPanel"))) Is Nothing Then
                    cboControlPanel.Items.FindByValue(Convert.ToString(Common.Globals.HostSettings("ControlPanel"))).Selected = True
                End If
            Else
                If Not cboControlPanel.Items.FindByValue(glbDefaultControlPanel) Is Nothing Then
                    cboControlPanel.Items.FindByValue(glbDefaultControlPanel).Selected = True
                End If
            End If

            Dim ctlList As New Common.Lists.ListController
            Dim colProcessor As Common.Lists.ListEntryInfoCollection = ctlList.GetListEntryInfoCollection("Processor", "")

            cboProcessor.DataSource = colProcessor
            cboProcessor.DataBind()
            cboProcessor.Items.Insert(0, New ListItem("<" + Services.Localization.Localization.GetString("None_Specified") + ">", ""))

            If Not cboProcessor.Items.FindByText(Common.Globals.HostSettings("PaymentProcessor").ToString) Is Nothing Then
                cboProcessor.Items.FindByText(Common.Globals.HostSettings("PaymentProcessor").ToString).Selected = True
            End If
            txtUserId.Text = Convert.ToString(Common.Globals.HostSettings("ProcessorUserId"))
            txtPassword.Attributes.Add("value", Convert.ToString(Common.Globals.HostSettings("ProcessorPassword")))

            txtHostFee.Text = Convert.ToString(Common.Globals.HostSettings("HostFee"))

            Dim colCurrency As Common.Lists.ListEntryInfoCollection = ctlList.GetListEntryInfoCollection("Currency", "")

            cboHostCurrency.DataSource = colCurrency
            cboHostCurrency.DataBind()
            If Not cboHostCurrency.Items.FindByValue(Convert.ToString(Common.Globals.HostSettings("HostCurrency"))) Is Nothing Then
                cboHostCurrency.Items.FindByValue(Common.Globals.HostSettings("HostCurrency").ToString).Selected = True
            Else
                cboHostCurrency.Items.FindByValue("USD").Selected = True
            End If
            If Not cboPerformance.Items.FindByValue(Convert.ToString(Common.Globals.HostSettings("PerformanceSetting"))) Is Nothing Then
                cboPerformance.Items.FindByValue(Common.Globals.HostSettings("PerformanceSetting").ToString).Selected = True
            Else
                cboPerformance.Items.FindByValue("3").Selected = True
            End If
            If Not cboSchedulerMode.Items.FindByValue(Convert.ToString(Common.Globals.HostSettings("SchedulerMode"))) Is Nothing Then
                cboSchedulerMode.Items.FindByValue(Common.Globals.HostSettings("SchedulerMode").ToString).Selected = True
            Else
                cboSchedulerMode.Items.FindByValue("1").Selected = True
            End If

            txtHostSpace.Text = Convert.ToString(Common.Globals.HostSettings("HostSpace"))
            If Convert.ToString(Common.Globals.HostSettings("SiteLogStorage")) = "" Then
                optSiteLogStorage.Items.FindByValue("D").Selected = True
            Else
                optSiteLogStorage.Items.FindByValue(Convert.ToString(Common.Globals.HostSettings("SiteLogStorage"))).Selected = True
            End If
            If Convert.ToString(Common.Globals.HostSettings("SiteLogBuffer")) = "" Then
                txtSiteLogBuffer.Text = "1"
            Else
                txtSiteLogBuffer.Text = Convert.ToString(Common.Globals.HostSettings("SiteLogBuffer"))
            End If
            txtSiteLogHistory.Text = Convert.ToString(Common.Globals.HostSettings("SiteLogHistory"))

            If Convert.ToString(Common.Globals.HostSettings("ModuleCaching")) = "" Then
                cboCacheMethod.Items.FindByValue("M").Selected = True
            Else
                cboCacheMethod.Items.FindByValue(Convert.ToString(Common.Globals.HostSettings("ModuleCaching"))).Selected = True
            End If

            txtDemoPeriod.Text = Convert.ToString(Common.Globals.HostSettings("DemoPeriod"))
            If Convert.ToString(Common.Globals.HostSettings("DemoSignup")) = "Y" Then
                chkDemoSignup.Checked = True
            Else
                chkDemoSignup.Checked = False
            End If
            If GetHashValue(Common.Globals.HostSettings("Copyright"), "Y") = "Y" Then
                chkCopyright.Checked = True
            Else
                chkCopyright.Checked = False
            End If
            If Common.Globals.HostSettings.ContainsKey("DisableUsersOnline") Then
                If Common.Globals.HostSettings("DisableUsersOnline").ToString = "Y" Then
                    chkUsersOnline.Checked = True
                Else
                    chkUsersOnline.Checked = False
                End If
            Else
                chkUsersOnline.Checked = False
            End If
            txtUsersOnlineTime.Text = Convert.ToString(Common.Globals.HostSettings("UsersOnlineTime"))
            txtAutoAccountUnlock.Text = Convert.ToString(Common.Globals.HostSettings("AutoAccountUnlockDuration"))
            txtProxyServer.Text = Convert.ToString(Common.Globals.HostSettings("ProxyServer"))
            txtProxyPort.Text = Convert.ToString(Common.Globals.HostSettings("ProxyPort"))
            txtProxyUsername.Text = Convert.ToString(Common.Globals.HostSettings("ProxyUsername"))
            txtProxyPassword.Attributes.Add("value", Convert.ToString(Common.Globals.HostSettings("ProxyPassword")))
            txtSMTPServer.Text = Convert.ToString(Common.Globals.HostSettings("SMTPServer"))
            If Convert.ToString(Common.Globals.HostSettings("SMTPAuthentication")) <> "" Then
                optSMTPAuthentication.Items.FindByValue(Common.Globals.HostSettings("SMTPAuthentication").ToString).Selected = True
            Else
                optSMTPAuthentication.Items.FindByValue("0").Selected = True
            End If

            txtSMTPUsername.Text = Convert.ToString(Common.Globals.HostSettings("SMTPUsername"))
            txtSMTPPassword.Attributes.Add("value", Convert.ToString(Common.Globals.HostSettings("SMTPPassword")))
            txtFileExtensions.Text = Convert.ToString(Common.Globals.HostSettings("FileExtensions"))

            If Common.Globals.HostSettings.ContainsKey("UseCustomErrorMessages") Then
                If Common.Globals.HostSettings("UseCustomErrorMessages").ToString = "Y" Then
                    chkUseCustomErrorMessages.Checked = True
                Else
                    chkUseCustomErrorMessages.Checked = False
                End If
            Else
                chkUseCustomErrorMessages.Checked = False
            End If

            If Common.Globals.HostSettings.ContainsKey("UseFriendlyUrls") Then
                If Common.Globals.HostSettings("UseFriendlyUrls").ToString = "Y" Then
                    chkUseFriendlyUrls.Checked = True
                Else
                    chkUseFriendlyUrls.Checked = False
                End If
            Else
                chkUseFriendlyUrls.Checked = False
            End If

            If Common.Globals.HostSettings.ContainsKey("EventLogBuffer") Then
                If Common.Globals.HostSettings("EventLogBuffer").ToString = "Y" Then
                    chkLogBuffer.Checked = True
                Else
                    chkLogBuffer.Checked = False
                End If
            Else
                chkLogBuffer.Checked = False
            End If

            If Convert.ToString(Common.Globals.HostSettings("SkinUpload")) <> "" Then
                optSkinUpload.Items.FindByValue(Common.Globals.HostSettings("SkinUpload").ToString).Selected = True
            Else
                optSkinUpload.Items.FindByValue("G").Selected = True
            End If

            txtHelpURL.Text = Convert.ToString(Common.Globals.HostSettings("HelpURL"))
            If Common.Globals.HostSettings.ContainsKey("EnableModuleOnLineHelp") Then
                If Common.Globals.HostSettings("EnableModuleOnLineHelp").ToString = "Y" Then
                    chkEnableHelp.Checked = True
                Else
                    chkEnableHelp.Checked = False
                End If
            Else
                chkEnableHelp.Checked = True
            End If

            ViewState.Item("SelectedSchedulerMode") = cboSchedulerMode.SelectedItem.Value
            ViewState.Item("SelectedLogBufferEnabled") = chkLogBuffer.Checked
            ViewState.Item("SelectedUsersOnlineEnabled") = chkUsersOnline.Checked



            ' Get the name of the data provider
            Dim objProviderConfiguration As Framework.Providers.ProviderConfiguration = Framework.Providers.ProviderConfiguration.GetProviderConfiguration("data")

            ' get list of script files
            Dim strProviderPath As String = PortalSettings.GetProviderPath()
            Dim arrScriptFiles As New ArrayList
            Dim strFile As String
            Dim arrFiles As String() = Directory.GetFiles(strProviderPath, "*." & objProviderConfiguration.DefaultProvider)
            For Each strFile In arrFiles
                arrScriptFiles.Add(Path.GetFileNameWithoutExtension(strFile))
            Next
            arrScriptFiles.Sort()

            cboUpgrade.DataSource = arrScriptFiles
            cboUpgrade.DataBind()

            Dim FileManagerModule As ModuleInfo = (New ModuleController).GetModuleByDefinition(Null.NullInteger, "File Manager")

            Dim params(2) As String

            params(0) = "mid=" & FileManagerModule.ModuleID
            params(1) = "ftype=" & UploadType.Skin.ToString
            params(2) = "rtab=" & Me.TabId
            lnkUploadSkin.NavigateUrl = NavigateURL(FileManagerModule.TabID, "Edit", params)


            params(1) = "ftype=" & UploadType.Container.ToString
            lnkUploadContainer.NavigateUrl = NavigateURL(FileManagerModule.TabID, "Edit", params)

        End Sub

#End Region

#Region "Event Handlers"

        ''' -----------------------------------------------------------------------------
        ''' <summary>
        ''' Page_Load runs when the control is loaded.
        ''' </summary>
        ''' <returns></returns>
        ''' <remarks>
        ''' </remarks>
        ''' <history>
        ''' 	[cnurse]	9/27/2004	Updated to reflect design changes for Help, 508 support
        '''                       and localisation
        '''     [VMasanas]  9/28/2004   Changed redirect to Access Denied
        ''' </history>
        ''' -----------------------------------------------------------------------------
        Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
            Try
                ' Verify that the current user has access to access this page
                If Not UserInfo.IsSuperUser Then
                    Response.Redirect(NavigateURL("Access Denied"), True)
                End If

                ' If this is the first visit to the page, populate the site data
                If Page.IsPostBack = False Then
                    BindData()
                End If

            Catch exc As Exception    'Module failed to load
                ProcessModuleLoadException(Me, exc)
            End Try

        End Sub

        ''' -----------------------------------------------------------------------------
        ''' <summary>
        ''' cmdEmail_Click runs when the test email button is clicked
        ''' </summary>
        ''' <returns></returns>
        ''' <remarks>
        ''' </remarks>
        ''' <history>
        ''' 	[cnurse]	9/27/2004	Updated to reflect design changes for Help, 508 support
        '''                       and localisation
        ''' </history>
        ''' -----------------------------------------------------------------------------
        Private Sub cmdEmail_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmdEmail.Click
            Try
                If txtHostEmail.Text <> "" Then

                    Dim strMessage As String = SendNotification(txtHostEmail.Text, txtHostEmail.Text, "", Services.Localization.Localization.GetSystemMessage(PortalSettings, "EMAIL_SMTP_TEST_SUBJECT"), "", "", "", txtSMTPServer.Text, optSMTPAuthentication.SelectedItem.Value, txtSMTPUsername.Text, txtSMTPPassword.Text)

                    If strMessage <> "" Then
                        lblEmail.Text = "<br>" & strMessage
                    Else
                        lblEmail.Text = "<br>" & Services.Localization.Localization.GetString("EmailSentMessage", Me.LocalResourceFile)
                    End If
                Else
                    lblEmail.Text = "<br>" & Services.Localization.Localization.GetString("SpecifyHostEmailMessage", Me.LocalResourceFile)
                End If

            Catch exc As Exception    'Module failed to load
                ProcessModuleLoadException(Me, exc)
            End Try
        End Sub

        ''' -----------------------------------------------------------------------------
        ''' <summary>
        ''' cmdProcessor_Click runs when the processor Go button is clicked
        ''' </summary>
        ''' <returns></returns>
        ''' <remarks>
        ''' </remarks>
        ''' <history>
        ''' 	[cnurse]	9/27/2004	Updated to reflect design changes for Help, 508 support
        '''                       and localisation
        ''' </history>
        ''' -----------------------------------------------------------------------------
        Private Sub cmdProcessor_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmdProcessor.Click
            Try
                Response.Redirect(AddHTTP(cboProcessor.SelectedItem.Value), True)

            Catch exc As Exception    'Module failed to load
                ProcessModuleLoadException(Me, exc)
            End Try
        End Sub

        ''' -----------------------------------------------------------------------------
        ''' <summary>
        ''' cmdEmail_Click runs when the clear cache button is clicked
        ''' </summary>
        ''' <returns></returns>
        ''' <remarks>
        ''' </remarks>
        ''' <history>
        ''' 	[cnurse]	9/27/2004	Updated to reflect design changes for Help, 508 support
        '''                       and localisation
        ''' </history>
        ''' -----------------------------------------------------------------------------
        Private Sub cmdCache_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmdCache.Click

            ' clear entire cache
            DataCache.ClearHostCache(True)

            Response.Redirect(Request.RawUrl, True)

        End Sub

        ''' -----------------------------------------------------------------------------
        ''' <summary>
        ''' cmdUpdate_Click runs when the Upgrade button is clicked
        ''' </summary>
        ''' <returns></returns>
        ''' <remarks>
        ''' </remarks>
        ''' <history>
        ''' 	[cnurse]	9/27/2004	Updated to reflect design changes for Help, 508 support
        '''                       and localisation
        ''' </history>
        ''' -----------------------------------------------------------------------------
        Private Sub cmdUpdate_Click(ByVal sender As Object, ByVal e As EventArgs) Handles cmdUpdate.Click
            Try

                Dim objHostSettings As New Entities.Host.HostSettingsController

                objHostSettings.UpdateHostSetting("HostPortalId", cboHostPortal.SelectedItem.Value)
                objHostSettings.UpdateHostSetting("HostTitle", txtHostTitle.Text)
                objHostSettings.UpdateHostSetting("HostURL", txtHostURL.Text)
                objHostSettings.UpdateHostSetting("HostEmail", txtHostEmail.Text)
                objHostSettings.UpdateHostSetting("PaymentProcessor", cboProcessor.SelectedItem.Text)
                objHostSettings.UpdateHostSetting("ProcessorUserId", txtUserId.Text, True)
                objHostSettings.UpdateHostSetting("ProcessorPassword", txtPassword.Text, True)
                objHostSettings.UpdateHostSetting("HostFee", txtHostFee.Text)
                objHostSettings.UpdateHostSetting("HostCurrency", cboHostCurrency.SelectedItem.Value)
                objHostSettings.UpdateHostSetting("HostSpace", txtHostSpace.Text)
                objHostSettings.UpdateHostSetting("SiteLogStorage", optSiteLogStorage.SelectedItem.Value)
                objHostSettings.UpdateHostSetting("SiteLogBuffer", txtSiteLogBuffer.Text)
                objHostSettings.UpdateHostSetting("SiteLogHistory", txtSiteLogHistory.Text)
                objHostSettings.UpdateHostSetting("DemoPeriod", txtDemoPeriod.Text)
                objHostSettings.UpdateHostSetting("DemoSignup", Convert.ToString(IIf(chkDemoSignup.Checked, "Y", "N")))
                objHostSettings.UpdateHostSetting("Copyright", Convert.ToString(IIf(chkCopyright.Checked, "Y", "N")))

                Dim OriginalUsersOnline As Boolean
                OriginalUsersOnline = CType(ViewState.Item("SelectedUsersOnlineEnabled"), Boolean)
                If OriginalUsersOnline <> chkUsersOnline.Checked Then
                    Dim objScheduleItem As Services.Scheduling.ScheduleItem
                    objScheduleItem = Services.Scheduling.SchedulingProvider.Instance.GetSchedule("DotNetNuke.Entities.Users.PurgeUsersOnline, DOTNETNUKE", Null.NullString)
                    If Not objScheduleItem Is Nothing Then
                        If Not chkUsersOnline.Checked Then
                            If Not objScheduleItem.Enabled Then
                                objScheduleItem.Enabled = True
                                Services.Scheduling.SchedulingProvider.Instance.UpdateSchedule(objScheduleItem)
                                If CType(cboSchedulerMode.SelectedItem.Value, Services.Scheduling.SchedulerMode) = Services.Scheduling.SchedulerMode.TIMER_METHOD Then
                                    Services.Scheduling.SchedulingProvider.Instance.ReStart("Host Settings")
                                End If
                            End If
                        Else
                            If objScheduleItem.Enabled Then
                                objScheduleItem.Enabled = False
                                Services.Scheduling.SchedulingProvider.Instance.UpdateSchedule(objScheduleItem)
                                If CType(cboSchedulerMode.SelectedItem.Value, Services.Scheduling.SchedulerMode) = Services.Scheduling.SchedulerMode.TIMER_METHOD Then
                                    Services.Scheduling.SchedulingProvider.Instance.ReStart("Host Settings")
                                End If
                            End If
                        End If
                    End If
                End If
                objHostSettings.UpdateHostSetting("DisableUsersOnline", Convert.ToString(IIf(chkUsersOnline.Checked, "Y", "N")))

                objHostSettings.UpdateHostSetting("AutoAccountUnlockDuration", txtAutoAccountUnlock.Text)
                objHostSettings.UpdateHostSetting("UsersOnlineTime", txtUsersOnlineTime.Text)
                objHostSettings.UpdateHostSetting("ProxyServer", txtProxyServer.Text)
                objHostSettings.UpdateHostSetting("ProxyPort", txtProxyPort.Text)
                objHostSettings.UpdateHostSetting("ProxyUsername", txtProxyUsername.Text, True)
                objHostSettings.UpdateHostSetting("ProxyPassword", txtProxyPassword.Text, True)
                objHostSettings.UpdateHostSetting("SMTPServer", txtSMTPServer.Text)
                objHostSettings.UpdateHostSetting("SMTPAuthentication", optSMTPAuthentication.SelectedItem.Value)
                objHostSettings.UpdateHostSetting("SMTPUsername", txtSMTPUsername.Text, True)
                objHostSettings.UpdateHostSetting("SMTPPassword", txtSMTPPassword.Text, True)
                objHostSettings.UpdateHostSetting("FileExtensions", txtFileExtensions.Text)
                objHostSettings.UpdateHostSetting("SkinUpload", optSkinUpload.SelectedItem.Value)
                objHostSettings.UpdateHostSetting("PerformanceSetting", cboPerformance.SelectedItem.Value)
                objHostSettings.UpdateHostSetting("UseCustomErrorMessages", Convert.ToString(IIf(chkUseCustomErrorMessages.Checked, "Y", "N")))
                objHostSettings.UpdateHostSetting("UseFriendlyUrls", Convert.ToString(IIf(chkUseFriendlyUrls.Checked, "Y", "N")))
                objHostSettings.UpdateHostSetting("ControlPanel", cboControlPanel.SelectedItem.Value)
                objHostSettings.UpdateHostSetting("SchedulerMode", cboSchedulerMode.SelectedItem.Value)
                objHostSettings.UpdateHostSetting("ModuleCaching", cboCacheMethod.SelectedItem.Value)
                objHostSettings.UpdateHostSetting("EnableModuleOnLineHelp", Convert.ToString(IIf(chkEnableHelp.Checked, "Y", "N")))
                objHostSettings.UpdateHostSetting("HelpURL", txtHelpURL.Text)

                Dim OriginalLogBuffer As Boolean
                OriginalLogBuffer = CType(ViewState.Item("SelectedLogBufferEnabled"), Boolean)
                If OriginalLogBuffer <> chkLogBuffer.Checked Then
                    Dim objScheduleItem As Services.Scheduling.ScheduleItem
                    objScheduleItem = Services.Scheduling.SchedulingProvider.Instance.GetSchedule("DotNetNuke.Services.Log.EventLog.PurgeLogBuffer, DOTNETNUKE", Null.NullString)
                    If Not objScheduleItem Is Nothing Then
                        If chkLogBuffer.Checked Then
                            If Not objScheduleItem.Enabled Then
                                objScheduleItem.Enabled = True
                                Services.Scheduling.SchedulingProvider.Instance.UpdateSchedule(objScheduleItem)
                                If CType(cboSchedulerMode.SelectedItem.Value, Services.Scheduling.SchedulerMode) = Services.Scheduling.SchedulerMode.TIMER_METHOD Then
                                    Services.Scheduling.SchedulingProvider.Instance.ReStart("Host Settings")
                                End If
                            End If
                        Else
                            If objScheduleItem.Enabled Then
                                objScheduleItem.Enabled = False
                                Services.Scheduling.SchedulingProvider.Instance.UpdateSchedule(objScheduleItem)
                                If CType(cboSchedulerMode.SelectedItem.Value, Services.Scheduling.SchedulerMode) = Services.Scheduling.SchedulerMode.TIMER_METHOD Then
                                    Services.Scheduling.SchedulingProvider.Instance.ReStart("Host Settings")
                                End If
                            End If
                        End If
                    End If
                End If
                objHostSettings.UpdateHostSetting("EventLogBuffer", Convert.ToString(IIf(chkLogBuffer.Checked, "Y", "N")))

                Dim objSkins As New UI.Skins.SkinController
                Dim blnAdminSkinChanged As Boolean = SkinChanged(SkinInfo.RootSkin, Null.NullInteger, SkinType.Admin, ctlAdminSkin.SkinSrc) OrElse SkinChanged(SkinInfo.RootContainer, Null.NullInteger, SkinType.Admin, ctlAdminContainer.SkinSrc)
                objSkins.SetSkin(SkinInfo.RootSkin, Null.NullInteger, SkinType.Portal, ctlHostSkin.SkinSrc)
                objSkins.SetSkin(SkinInfo.RootContainer, Null.NullInteger, SkinType.Portal, ctlHostContainer.SkinSrc)
                objSkins.SetSkin(SkinInfo.RootSkin, Null.NullInteger, SkinType.Admin, ctlAdminSkin.SkinSrc)
                objSkins.SetSkin(SkinInfo.RootContainer, Null.NullInteger, SkinType.Admin, ctlAdminContainer.SkinSrc)

                ' clear host settings cache
                DataCache.ClearHostCache(True)

                Dim OriginalSchedulerMode As Services.Scheduling.SchedulerMode
                OriginalSchedulerMode = CType(ViewState.Item("SelectedSchedulerMode"), Services.Scheduling.SchedulerMode)

                If CType(cboSchedulerMode.SelectedItem.Value, Services.Scheduling.SchedulerMode) = Services.Scheduling.SchedulerMode.DISABLED Then
                    If OriginalSchedulerMode <> Services.Scheduling.SchedulerMode.DISABLED Then
                        Services.Scheduling.SchedulingProvider.Instance.Halt("Host Settings")
                    End If
                ElseIf CType(cboSchedulerMode.SelectedItem.Value, Services.Scheduling.SchedulerMode) = Services.Scheduling.SchedulerMode.TIMER_METHOD Then
                    If OriginalSchedulerMode = Services.Scheduling.SchedulerMode.DISABLED Or OriginalSchedulerMode = Services.Scheduling.SchedulerMode.REQUEST_METHOD Then
                        Dim newThread As New Threading.Thread(AddressOf Services.Scheduling.SchedulingProvider.Instance.Start)
                        newThread.IsBackground = True
                        newThread.Start()
                    End If
                ElseIf CType(cboSchedulerMode.SelectedItem.Value, Services.Scheduling.SchedulerMode) <> Services.Scheduling.SchedulerMode.TIMER_METHOD Then
                    If OriginalSchedulerMode = Services.Scheduling.SchedulerMode.TIMER_METHOD Then
                        Services.Scheduling.SchedulingProvider.Instance.Halt("Host Settings")
                    End If
                End If

                ' this is needed in order to fully flush the cache after changing FriendlyURL
                Response.Redirect(Request.RawUrl, True)

                ' Redirect to this site to refresh only if admin skin changed
                'If blnAdminSkinChanged Then Response.Redirect(Request.RawUrl, True)

            Catch exc As Exception    'Module failed to load
                ProcessModuleLoadException(Me, exc)
            End Try
        End Sub

        Private Function SkinChanged(ByVal SkinRoot As String, ByVal PortalId As Integer, ByVal SkinType As DotNetNuke.ui.Skins.SkinType, ByVal PostedSkinSrc As String) As Boolean
            Dim objSkins As New UI.Skins.SkinController
            Dim objSkinInfo As UI.Skins.SkinInfo
            Dim strSkinSrc As String
            objSkinInfo = objSkins.GetSkin(SkinRoot, PortalId, SkinType.Admin)
            If Not objSkinInfo Is Nothing Then strSkinSrc = objSkinInfo.SkinSrc
            If strSkinSrc Is Nothing Then strSkinSrc = ""
            Return strSkinSrc <> PostedSkinSrc
        End Function

        ''' -----------------------------------------------------------------------------
        ''' <summary>
        ''' cmdUpgrade_Click runs when the Upgrade Log Go button is clicked
        ''' </summary>
        ''' <returns></returns>
        ''' <remarks>
        ''' </remarks>
        ''' <history>
        ''' 	[cnurse]	9/27/2004	Updated to reflect design changes for Help, 508 support
        '''                       and localisation
        ''' </history>
        ''' -----------------------------------------------------------------------------
        Private Sub cmdUpgrade_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmdUpgrade.Click
            Try
                ' get path to provider
                Dim strProviderPath As String = PortalSettings.GetProviderPath()

                If File.Exists(strProviderPath & cboUpgrade.SelectedItem.Text & ".log") Then
                    Dim objStreamReader As StreamReader
                    objStreamReader = File.OpenText(strProviderPath & cboUpgrade.SelectedItem.Text & ".log")
                    lblUpgrade.Text = Replace(objStreamReader.ReadToEnd, ControlChars.Lf, "<br>")
                    objStreamReader.Close()
                Else
                    lblUpgrade.Text = Services.Localization.Localization.GetString("ScriptFailure", Me.LocalResourceFile)
                End If

            Catch exc As Exception    'Module failed to load
                ProcessModuleLoadException(Me, exc)
            End Try
        End Sub

#End Region

#Region " Web Form Designer Generated Code "

        'This call is required by the Web Form Designer.
        <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

        End Sub

        Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
            'CODEGEN: This method call is required by the Web Form Designer
            'Do not modify it using the code editor.
            InitializeComponent()
        End Sub

#End Region


    End Class

End Namespace

