'
' DotNetNuke - http://www.dotnetnuke.com
' Copyright (c) 2002-2005
' by Perpetual Motion Interactive Systems Inc. ( http://www.perpetualmotion.ca )
'
' Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated 
' documentation files (the "Software"), to deal in the Software without restriction, including without limitation 
' the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and 
' to permit persons to whom the Software is furnished to do so, subject to the following conditions:
'
' The above copyright notice and this permission notice shall be included in all copies or substantial portions 
' of the Software.
'
' THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED 
' TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL 
' THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF 
' CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
' DEALINGS IN THE SOFTWARE.
'
Imports System.Web.UI.WebControls
Imports DotNetNuke
Imports System.Reflection
Imports System.IO
Imports DotNetNuke.Entities.Modules
Imports DotNetNuke.Services.FileSystem
Imports DotNetNuke.Services.Localization

Namespace DotNetNuke.Modules.Admin.Modules

	''' -----------------------------------------------------------------------------
	''' <summary>
	''' </summary>
	''' <returns></returns>
	''' <remarks>
	''' </remarks>
	''' <history>
	''' </history>
	''' -----------------------------------------------------------------------------
    Public MustInherit Class Export
		Inherits Entities.Modules.PortalModuleBase

#Region "Controls"

        Protected plFile As UI.UserControls.LabelControl
        Protected WithEvents lblFile As System.Web.UI.WebControls.Label

        Protected WithEvents cmdExport As System.Web.UI.WebControls.LinkButton
        Protected WithEvents cmdCancel As System.Web.UI.WebControls.LinkButton

#End Region

#Region "Private Members"

        Private Shadows ModuleId As Integer = -1

#End Region

#Region "Event Handlers"

        ''' -----------------------------------------------------------------------------
        ''' <summary>
        ''' </summary>
        ''' <remarks>
        ''' </remarks>
        ''' <history>
        ''' </history>
        ''' -----------------------------------------------------------------------------
        Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
            Try
                If Not Request.QueryString("moduleid") Is Nothing Then
                    ModuleId = Int32.Parse(Request.QueryString("moduleid"))
                End If

                Dim objModules As New ModuleController
                Dim objModule As ModuleInfo = objModules.GetModule(ModuleId, TabId)
                If Not objModule Is Nothing Then
                    lblFile.Text = "content." & CleanName(objModule.FriendlyName) & "." & CleanName(objModule.ModuleTitle) & ".xml"
                End If

            Catch exc As Exception    'Module failed to load
                ProcessModuleLoadException(Me, exc)
            End Try
        End Sub

        ''' -----------------------------------------------------------------------------
        ''' <summary>
        ''' </summary>
        ''' <remarks>
        ''' </remarks>
        ''' <history>
        ''' </history>
        ''' -----------------------------------------------------------------------------
        Private Sub cmdCancel_Click(ByVal sender As Object, ByVal e As EventArgs) Handles cmdCancel.Click
            Try
                Response.Redirect(NavigateURL(), True)
            Catch exc As Exception    'Module failed to load
                ProcessModuleLoadException(Me, exc)
            End Try
        End Sub

        ''' -----------------------------------------------------------------------------
        ''' <summary>
        ''' </summary>
        ''' <remarks>
        ''' </remarks>
        ''' <history>
        ''' </history>
        ''' -----------------------------------------------------------------------------
        Private Sub cmdExport_Click(ByVal sender As Object, ByVal e As EventArgs) Handles cmdExport.Click
            Try
                Dim strMessage As String = ExportModule(ModuleId, lblFile.Text)
                If strMessage = "" Then
                    Response.Redirect(NavigateURL(), True)
                Else
                    UI.Skins.Skin.AddModuleMessage(Me, strMessage, UI.Skins.Controls.ModuleMessage.ModuleMessageType.RedError)
                End If
            Catch exc As Exception    'Module failed to load
                ProcessModuleLoadException(Me, exc)
            End Try
        End Sub

#End Region

#Region "Private Methods"

        Private Function ExportModule(ByVal ModuleID As Integer, ByVal FileName As String) As String

            Dim strMessage As String = ""

            Dim objModules As New ModuleController
            Dim objModule As ModuleInfo = objModules.GetModule(ModuleID, TabId)
            If Not objModule Is Nothing Then
                If objModule.BusinessControllerClass <> "" And objModule.IsPortable Then
                    Try
                        Dim objObject As Object = Framework.Reflection.CreateObject(objModule.BusinessControllerClass, objModule.BusinessControllerClass)

                        'Double-check
                        If TypeOf objObject Is IPortable Then

                            Dim Content As String = CType(CType(objObject, IPortable).ExportModule(ModuleID), String)

                            If Content <> "" Then
                                ' add attributes to XML document
                                Content = "<?xml version=""1.0"" encoding=""utf-8"" ?>" & _
                                  "<content type=""" & CleanName(objModule.FriendlyName) & """ version=""" & objModule.Version & """>" & _
                                  Content & _
                                  "</content>"

                                'First check the Portal limits will not be exceeded (this is approximate)
                                Dim objPortalController As New PortalController
                                Dim strFile As String = PortalSettings.HomeDirectoryMapPath & FileName
                                If ((((objPortalController.GetPortalSpaceUsed(PortalId) + Content.Length) / 1000000) <= PortalSettings.HostSpace) Or PortalSettings.HostSpace = 0) Then
                                    ' save the file
                                    Dim objStream As StreamWriter
                                    objStream = File.CreateText(strFile)
                                    objStream.WriteLine(Content)
                                    objStream.Close()

                                    ' add file to Files table
                                    Dim objFiles As New FileController
                                    Dim finfo As New System.IO.FileInfo(strFile)
                                    objFiles.AddFile(PortalId, lblFile.Text, "xml", finfo.Length, 0, 0, "application/octet-stream", "")
                                Else
                                    strMessage += "<br>" & String.Format(Localization.GetString("DiskSpaceExceeded"), strFile)
                                End If
                            Else
                                strMessage = Localization.GetString("NoContent", Me.LocalResourceFile)
                            End If
                        Else
                            strMessage = Localization.GetString("ExportNotSupported", Me.LocalResourceFile)
                        End If
                    Catch
                        strMessage = Localization.GetString("Error", Me.LocalResourceFile)
                    End Try
                Else
                    strMessage = Localization.GetString("ExportNotSupported", Me.LocalResourceFile)
                End If
            End If

            Return strMessage

        End Function

        Private Function CleanName(ByVal Name As String) As String

            Dim strName As String = Name
            Dim strBadChars As String = ". ~`!@#$%^&*()-_+={[}]|\:;<,>?/" & Chr(34) & Chr(39)

            Dim intCounter As Integer
            For intCounter = 0 To Len(strBadChars) - 1
                strName = strName.Replace(strBadChars.Substring(intCounter, 1), "")
            Next intCounter

            Return strName

        End Function

#End Region

#Region " Web Form Designer Generated Code "

        'This call is required by the Web Form Designer.
        <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

        End Sub

        Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
            'CODEGEN: This method call is required by the Web Form Designer
            'Do not modify it using the code editor.
            InitializeComponent()
        End Sub

#End Region

    End Class

End Namespace
