'
' DotNetNuke - http://www.dotnetnuke.com
' Copyright (c) 2002-2005
' by Perpetual Motion Interactive Systems Inc. ( http://www.perpetualmotion.ca )
'
' Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated 
' documentation files (the "Software"), to deal in the Software without restriction, including without limitation 
' the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and 
' to permit persons to whom the Software is furnished to do so, subject to the following conditions:
'
' The above copyright notice and this permission notice shall be included in all copies or substantial portions 
' of the Software.
'
' THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED 
' TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL 
' THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF 
' CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
' DEALINGS IN THE SOFTWARE.
'
Imports DotNetNuke.UI.Utilities
Imports DotNetNuke.Entities

Namespace DotNetNuke.UI.Skins.Controls
	''' -----------------------------------------------------------------------------
	''' <summary></summary>
	''' <returns></returns>
	''' <remarks></remarks>
	''' <history>
	''' 	[cniknet]	10/15/2004	Replaced public members with properties and removed
	'''                             brackets from property names
	''' </history>
	''' -----------------------------------------------------------------------------


	Public MustInherit Class Search

		Inherits UI.Skins.SkinObjectBase

		' private members
		Private _submit As String
		Private _cssClass As String

		Const MyFileName As String = "Search.ascx"

		' protected controls
		Protected WithEvents txtSearch As System.Web.UI.WebControls.TextBox
		Protected WithEvents cmdSearch As System.Web.UI.WebControls.LinkButton

#Region "Public Members"
		Public Property Submit() As String
			Get
				Return _submit
			End Get
			Set(ByVal Value As String)
				_submit = Value
			End Set
		End Property

		Public Property CssClass() As String
			Get
				Return _cssClass
			End Get
			Set(ByVal Value As String)
				_cssClass = Value
			End Set
		End Property
#End Region

#Region " Web Form Designer Generated Code "


		<System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

		End Sub

		Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
			'CODEGEN: This method call is required by the Web Form Designer
			'Do not modify it using the code editor.
			InitializeComponent()
		End Sub

#End Region

		'*******************************************************
		'
		' The Page_Load server event handler on this page is used
		' to populate the role information for the page
		'
		'*******************************************************

		Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
            If Not Page.IsPostBack Then
                ClientAPI.RegisterKeyCapture(Me.txtSearch, Me.cmdSearch, Asc(vbCr))

                If Not Request.QueryString("Search") Is Nothing Then
                    txtSearch.Text = Request.QueryString("Search").ToString
                End If

                If Submit <> "" Then
                    If Submit.IndexOf("src=") <> -1 Then
                        Submit = Replace(Submit, "src=""", "src=""" & PortalSettings.ActiveTab.SkinPath)
                    End If
                Else
                    Submit = Services.Localization.Localization.GetString("Search", Services.Localization.Localization.GetResourceFile(Me, MyFileName))
                End If
                cmdSearch.Text = Submit

                If CssClass <> "" Then
                    cmdSearch.CssClass = CssClass
                End If
            End If

		End Sub

		Private Sub cmdSearch_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmdSearch.Click

			If txtSearch.Text <> "" Then
                Dim objModules As New Entities.Modules.ModuleController
                Dim searchTabId As Integer = objModules.GetModuleByDefinition(PortalSettings.PortalId, "Search Results").TabID
                If Host.HostSettings.GetHostSetting("UseFriendlyUrls") = "Y" Then
                    Response.Redirect(NavigateURL(searchTabId) & "?Search=" & Server.UrlEncode(txtSearch.Text))
                Else
                    Response.Redirect(NavigateURL(searchTabId) & "&Search=" & Server.UrlEncode(txtSearch.Text))
                End If
            End If

		End Sub

	End Class

End Namespace
