'
' DotNetNuke - http://www.dotnetnuke.com
' Copyright (c) 2002-2005
' by Perpetual Motion Interactive Systems Inc. ( http://www.perpetualmotion.ca )
'
' Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated 
' documentation files (the "Software"), to deal in the Software without restriction, including without limitation 
' the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and 
' to permit persons to whom the Software is furnished to do so, subject to the following conditions:
'
' The above copyright notice and this permission notice shall be included in all copies or substantial portions 
' of the Software.
'
' THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED 
' TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL 
' THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF 
' CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
' DEALINGS IN THE SOFTWARE.
'
Imports DotNetNuke.Entities.Tabs

Namespace DotNetNuke.UI.Skins.Controls
    ''' -----------------------------------------------------------------------------
    ''' <summary></summary>
    ''' <returns></returns>
    ''' <remarks></remarks>
    ''' <history>
    ''' 	[cniknet]	10/15/2004	Replaced public members with properties and removed
    '''                             brackets from property names
    ''' </history>
    ''' -----------------------------------------------------------------------------


    Public MustInherit Class SolPartMenu

        Inherits UI.Skins.SkinObjectBase

#Region "Private Members"
        Private _separateCss As String
        Private _menuBarCssClass As String
        Private _menuContainerCssClass As String
        Private _menuItemCssClass As String
        Private _menuIconCssClass As String
        Private _subMenuCssClass As String
        Private _menuItemSelCssClass As String
        Private _menuBreakCssClass As String
        Private _menuArrowCssClass As String
        Private _menuRootArrowCssClass As String
        Private _backColor As String
        Private _foreColor As String
        Private _highlightColor As String
        Private _iconBackgroundColor As String
        Private _selectedBorderColor As String
        Private _selectedColor As String
        Private _selectedForeColor As String
        Private _display As String
        Private _menuBarHeight As String
        Private _menuBorderWidth As String
        Private _menuItemHeight As String
        Private _forceDownLevel As String
        Private _moveable As String
        Private _iconWidth As String
        Private _menuEffectsShadowColor As String
        Private _menuEffectsMouseOutHideDelay As String
        Private _mouseOutHideDelay As String
        Private _menuEffectsMouseOverDisplay As String
        Private _menuEffectsMouseOverExpand As String
        Private _menuEffectsStyle As String
        Private _fontNames As String
        Private _fontSize As String
        Private _fontBold As String
        Private _menuEffectsShadowStrength As String
        Private _menuEffectsMenuTransition As String
        Private _menuEffectsMenuTransitionLength As String
        Private _menuEffectsShadowDirection As String
        Private _forceFullMenuList As String
        Private _useSkinPathArrowImages As String
        Private _useRootBreadCrumbArrow As String
        Private _useSubMenuBreadCrumbArrow As String
        Private _rootMenuItemBreadCrumbCssClass As String
        Private _subMenuItemBreadCrumbCssClass As String
        Private _rootMenuItemCssClass As String
        Private _rootBreadCrumbArrow As String
        Private _subMenuBreadCrumbArrow As String
        Private _useArrows As String
        Private _downArrow As String
        Private _rightArrow As String
        Private _level As String
        Private _rootOnly As String
        Private _rootMenuItemActiveCssClass As String
        Private _subMenuItemActiveCssClass As String
        Private _rootMenuItemSelectedCssClass As String
        Private _subMenuItemSelectedCssClass As String
        Private _separator As String
        Private _separatorCssClass As String
        Private _rootMenuItemLeftHtml As String
        Private _rootMenuItemRightHtml As String
        Private _subMenuItemLeftHtml As String
        Private _subMenuItemRightHtml As String
        Private _toolTip As String
        Private _leftSeparator As String
        Private _rightSeparator As String
        Private _leftSeparatorActive As String
        Private _rightSeparatorActive As String
        Private _leftSeparatorBreadCrumb As String
        Private _rightSeparatorBreadCrumb As String
        Private _leftSeparatorCssClass As String
        Private _rightSeparatorCssClass As String
        Private _leftSeparatorActiveCssClass As String
        Private _rightSeparatorActiveCssClass As String
        Private _leftSeparatorBreadCrumbCssClass As String
        Private _rightSeparatorBreadCrumbCssClass As String
        Private _menuAlignment As String
        Private _clearDefaults As String
        Private _delaySubmenuLoad As String

        Private PreviousRootBreadcrumbFlag As Boolean
        Private PreviousRootActiveFlag As Boolean
        Private NextRootBreadcrumbFlag As Boolean
        Private NextRootActiveFlag As Boolean
#End Region

        ' protected controls
        Protected WithEvents ctlMenu As SolpartWebControls.SolpartMenu


#Region "Public Members"
        Public Property SeparateCss() As String
            Get
                Return _separateCss
            End Get
            Set(ByVal Value As String)
                _separateCss = Value
            End Set
        End Property

        Public Property MenuBarCssClass() As String
            Get
                Return _menuBarCssClass
            End Get
            Set(ByVal Value As String)
                _menuBarCssClass = Value
            End Set
        End Property

        Public Property MenuContainerCssClass() As String
            Get
                Return _menuContainerCssClass
            End Get
            Set(ByVal Value As String)
                _menuContainerCssClass = Value
            End Set
        End Property

        Public Property MenuItemCssClass() As String
            Get
                Return _menuItemCssClass
            End Get
            Set(ByVal Value As String)
                _menuItemCssClass = Value
            End Set
        End Property

        Public Property MenuIconCssClass() As String
            Get
                Return _menuIconCssClass
            End Get
            Set(ByVal Value As String)
                _menuIconCssClass = Value
            End Set
        End Property

        Public Property SubMenuCssClass() As String
            Get
                Return _subMenuCssClass
            End Get
            Set(ByVal Value As String)
                _subMenuCssClass = Value
            End Set
        End Property

        Public Property MenuItemSelCssClass() As String
            Get
                Return _menuItemSelCssClass
            End Get
            Set(ByVal Value As String)
                _menuItemSelCssClass = Value
            End Set
        End Property

        Public Property MenuBreakCssClass() As String
            Get
                Return _menuBreakCssClass
            End Get
            Set(ByVal Value As String)
                _menuBreakCssClass = Value
            End Set
        End Property

        Public Property MenuArrowCssClass() As String
            Get
                Return _menuArrowCssClass
            End Get
            Set(ByVal Value As String)
                _menuArrowCssClass = Value
            End Set
        End Property

        Public Property MenuRootArrowCssClass() As String
            Get
                Return _menuRootArrowCssClass
            End Get
            Set(ByVal Value As String)
                _menuRootArrowCssClass = Value
            End Set
        End Property

        Public Property BackColor() As String
            Get
                Return _backColor
            End Get
            Set(ByVal Value As String)
                _backColor = Value
            End Set
        End Property

        Public Property ForeColor() As String
            Get
                Return _foreColor
            End Get
            Set(ByVal Value As String)
                _foreColor = Value
            End Set
        End Property

        Public Property HighlightColor() As String
            Get
                Return _highlightColor
            End Get
            Set(ByVal Value As String)
                _highlightColor = Value
            End Set
        End Property

        Public Property IconBackgroundColor() As String
            Get
                Return _iconBackgroundColor
            End Get
            Set(ByVal Value As String)
                _iconBackgroundColor = Value
            End Set
        End Property

        Public Property SelectedBorderColor() As String
            Get
                Return _selectedBorderColor
            End Get
            Set(ByVal Value As String)
                _selectedBorderColor = Value
            End Set
        End Property

        Public Property SelectedColor() As String
            Get
                Return _selectedColor
            End Get
            Set(ByVal Value As String)
                _selectedColor = Value
            End Set
        End Property

        Public Property SelectedForeColor() As String
            Get
                Return _selectedForeColor
            End Get
            Set(ByVal Value As String)
                _selectedForeColor = Value
            End Set
        End Property

        Public Property Display() As String
            Get
                Return _display
            End Get
            Set(ByVal Value As String)
                _display = Value
            End Set
        End Property

        Public Property MenuBarHeight() As String
            Get
                Return _menuBarHeight
            End Get
            Set(ByVal Value As String)
                _menuBarHeight = Value
            End Set
        End Property

        Public Property MenuBorderWidth() As String
            Get
                Return _menuBorderWidth
            End Get
            Set(ByVal Value As String)
                _menuBorderWidth = Value
            End Set
        End Property

        Public Property MenuItemHeight() As String
            Get
                Return _menuItemHeight
            End Get
            Set(ByVal Value As String)
                _menuItemHeight = Value
            End Set
        End Property

        Public Property ForceDownLevel() As String
            Get
                Return _forceDownLevel
            End Get
            Set(ByVal Value As String)
                _forceDownLevel = Value
            End Set
        End Property

        Public Property Moveable() As String
            Get
                Return _moveable
            End Get
            Set(ByVal Value As String)
                _moveable = Value
            End Set
        End Property

        Public Property IconWidth() As String
            Get
                Return _iconWidth
            End Get
            Set(ByVal Value As String)
                _iconWidth = Value
            End Set
        End Property

        Public Property MenuEffectsShadowColor() As String
            Get
                Return _menuEffectsShadowColor
            End Get
            Set(ByVal Value As String)
                _menuEffectsShadowColor = Value
            End Set
        End Property

        Public Property MenuEffectsMouseOutHideDelay() As String
            Get
                Return _menuEffectsMouseOutHideDelay
            End Get
            Set(ByVal Value As String)
                _menuEffectsMouseOutHideDelay = Value
            End Set
        End Property

        Public Property MouseOutHideDelay() As String
            Get
                Return _mouseOutHideDelay
            End Get
            Set(ByVal Value As String)
                _mouseOutHideDelay = Value
            End Set
        End Property

        Public Property MenuEffectsMouseOverDisplay() As String
            Get
                Return _menuEffectsMouseOverDisplay
            End Get
            Set(ByVal Value As String)
                _menuEffectsMouseOverDisplay = Value
            End Set
        End Property

        Public Property MenuEffectsMouseOverExpand() As String
            Get
                Return _menuEffectsMouseOverExpand
            End Get
            Set(ByVal Value As String)
                _menuEffectsMouseOverExpand = Value
            End Set
        End Property

        Public Property MenuEffectsStyle() As String
            Get
                Return _menuEffectsStyle
            End Get
            Set(ByVal Value As String)
                _menuEffectsStyle = Value
            End Set
        End Property

        Public Property FontNames() As String
            Get
                Return _fontNames
            End Get
            Set(ByVal Value As String)
                _fontNames = Value
            End Set
        End Property

        Public Property FontSize() As String
            Get
                Return _fontSize
            End Get
            Set(ByVal Value As String)
                _fontSize = Value
            End Set
        End Property

        Public Property FontBold() As String
            Get
                Return _fontBold
            End Get
            Set(ByVal Value As String)
                _fontBold = Value
            End Set
        End Property

        Public Property MenuEffectsShadowStrength() As String
            Get
                Return _menuEffectsShadowStrength
            End Get
            Set(ByVal Value As String)
                _menuEffectsShadowStrength = Value
            End Set
        End Property

        Public Property MenuEffectsMenuTransition() As String
            Get
                Return _menuEffectsMenuTransition
            End Get
            Set(ByVal Value As String)
                _menuEffectsMenuTransition = Value
            End Set
        End Property

        Public Property MenuEffectsMenuTransitionLength() As String
            Get
                Return _menuEffectsMenuTransitionLength
            End Get
            Set(ByVal Value As String)
                _menuEffectsMenuTransitionLength = Value
            End Set
        End Property

        Public Property MenuEffectsShadowDirection() As String
            Get
                Return _menuEffectsShadowDirection
            End Get
            Set(ByVal Value As String)
                _menuEffectsShadowDirection = Value
            End Set
        End Property

        Public Property ForceFullMenuList() As String
            Get
                Return _forceFullMenuList
            End Get
            Set(ByVal Value As String)
                _forceFullMenuList = Value
            End Set
        End Property

        Public Property UseSkinPathArrowImages() As String
            Get
                Return _useSkinPathArrowImages
            End Get
            Set(ByVal Value As String)
                _useSkinPathArrowImages = Value
            End Set
        End Property

        Public Property UseRootBreadCrumbArrow() As String
            Get
                Return _useRootBreadCrumbArrow
            End Get
            Set(ByVal Value As String)
                _useRootBreadCrumbArrow = Value
            End Set
        End Property

        Public Property UseSubMenuBreadCrumbArrow() As String
            Get
                Return _useSubMenuBreadCrumbArrow
            End Get
            Set(ByVal Value As String)
                _useSubMenuBreadCrumbArrow = Value
            End Set
        End Property

        Public Property RootMenuItemBreadCrumbCssClass() As String
            Get
                Return _rootMenuItemBreadCrumbCssClass
            End Get
            Set(ByVal Value As String)
                _rootMenuItemBreadCrumbCssClass = Value
            End Set
        End Property

        Public Property SubMenuItemBreadCrumbCssClass() As String
            Get
                Return _subMenuItemBreadCrumbCssClass
            End Get
            Set(ByVal Value As String)
                _subMenuItemBreadCrumbCssClass = Value
            End Set
        End Property

        Public Property RootMenuItemCssClass() As String
            Get
                Return _rootMenuItemCssClass
            End Get
            Set(ByVal Value As String)
                _rootMenuItemCssClass = Value
            End Set
        End Property

        Public Property RootBreadCrumbArrow() As String
            Get
                Return _rootBreadCrumbArrow
            End Get
            Set(ByVal Value As String)
                _rootBreadCrumbArrow = Value
            End Set
        End Property

        Public Property SubMenuBreadCrumbArrow() As String
            Get
                Return _subMenuBreadCrumbArrow
            End Get
            Set(ByVal Value As String)
                _subMenuBreadCrumbArrow = Value
            End Set
        End Property

        Public Property UseArrows() As String
            Get
                Return _useArrows
            End Get
            Set(ByVal Value As String)
                _useArrows = Value
            End Set
        End Property

        Public Property DownArrow() As String
            Get
                Return _downArrow
            End Get
            Set(ByVal Value As String)
                _downArrow = Value
            End Set
        End Property

        Public Property RightArrow() As String
            Get
                Return _rightArrow
            End Get
            Set(ByVal Value As String)
                _rightArrow = Value
            End Set
        End Property

        Public Property Level() As String
            Get
                Return _level
            End Get
            Set(ByVal Value As String)
                _level = Value
            End Set
        End Property

        Public Property RootOnly() As String
            Get
                Return _rootOnly
            End Get
            Set(ByVal Value As String)
                _rootOnly = Value
            End Set
        End Property

        Public Property RootMenuItemActiveCssClass() As String
            Get
                Return _rootMenuItemActiveCssClass
            End Get
            Set(ByVal Value As String)
                _rootMenuItemActiveCssClass = Value
            End Set
        End Property

        Public Property SubMenuItemActiveCssClass() As String
            Get
                Return _subMenuItemActiveCssClass
            End Get
            Set(ByVal Value As String)
                _subMenuItemActiveCssClass = Value
            End Set
        End Property

        Public Property RootMenuItemSelectedCssClass() As String
            Get
                Return _rootMenuItemSelectedCssClass
            End Get
            Set(ByVal Value As String)
                _rootMenuItemSelectedCssClass = Value
            End Set
        End Property

        Public Property SubMenuItemSelectedCssClass() As String
            Get
                Return _subMenuItemSelectedCssClass
            End Get
            Set(ByVal Value As String)
                _subMenuItemSelectedCssClass = Value
            End Set
        End Property

        Public Property Separator() As String
            Get
                Return _separator
            End Get
            Set(ByVal Value As String)
                _separator = Value
            End Set
        End Property

        Public Property SeparatorCssClass() As String
            Get
                Return _separatorCssClass
            End Get
            Set(ByVal Value As String)
                _separatorCssClass = Value
            End Set
        End Property

        Public Property RootMenuItemLeftHtml() As String
            Get
                Return _rootMenuItemLeftHtml
            End Get
            Set(ByVal Value As String)
                _rootMenuItemLeftHtml = Value
            End Set
        End Property

        Public Property RootMenuItemRightHtml() As String
            Get
                Return _rootMenuItemRightHtml
            End Get
            Set(ByVal Value As String)
                _rootMenuItemRightHtml = Value
            End Set
        End Property

        Public Property SubMenuItemLeftHtml() As String
            Get
                Return _subMenuItemLeftHtml
            End Get
            Set(ByVal Value As String)
                _subMenuItemLeftHtml = Value
            End Set
        End Property

        Public Property SubMenuItemRightHtml() As String
            Get
                Return _subMenuItemRightHtml
            End Get
            Set(ByVal Value As String)
                _subMenuItemRightHtml = Value
            End Set
        End Property

        Public Property ToolTip() As String
            Get
                Return _toolTip
            End Get
            Set(ByVal Value As String)
                _toolTip = Value
            End Set
        End Property

        Public Property LeftSeparator() As String
            Get
                Return _leftSeparator
            End Get
            Set(ByVal Value As String)
                _leftSeparator = Value
            End Set
        End Property

        Public Property RightSeparator() As String
            Get
                Return _rightSeparator
            End Get
            Set(ByVal Value As String)
                _rightSeparator = Value
            End Set
        End Property

        Public Property LeftSeparatorActive() As String
            Get
                Return _leftSeparatorActive
            End Get
            Set(ByVal Value As String)
                _leftSeparatorActive = Value
            End Set
        End Property

        Public Property RightSeparatorActive() As String
            Get
                Return _rightSeparatorActive
            End Get
            Set(ByVal Value As String)
                _rightSeparatorActive = Value
            End Set
        End Property

        Public Property LeftSeparatorBreadCrumb() As String
            Get
                Return _leftSeparatorBreadCrumb
            End Get
            Set(ByVal Value As String)
                _leftSeparatorBreadCrumb = Value
            End Set
        End Property

        Public Property RightSeparatorBreadCrumb() As String
            Get
                Return _rightSeparatorBreadCrumb
            End Get
            Set(ByVal Value As String)
                _rightSeparatorBreadCrumb = Value
            End Set
        End Property

        Public Property LeftSeparatorCssClass() As String
            Get
                Return _leftSeparatorCssClass
            End Get
            Set(ByVal Value As String)
                _leftSeparatorCssClass = Value
            End Set
        End Property

        Public Property RightSeparatorCssClass() As String
            Get
                Return _rightSeparatorCssClass
            End Get
            Set(ByVal Value As String)
                _rightSeparatorCssClass = Value
            End Set
        End Property

        Public Property LeftSeparatorActiveCssClass() As String
            Get
                Return _leftSeparatorActiveCssClass
            End Get
            Set(ByVal Value As String)
                _leftSeparatorActiveCssClass = Value
            End Set
        End Property

        Public Property RightSeparatorActiveCssClass() As String
            Get
                Return _rightSeparatorActiveCssClass
            End Get
            Set(ByVal Value As String)
                _rightSeparatorActiveCssClass = Value
            End Set
        End Property

        Public Property LeftSeparatorBreadCrumbCssClass() As String
            Get
                Return _leftSeparatorBreadCrumbCssClass
            End Get
            Set(ByVal Value As String)
                _leftSeparatorBreadCrumbCssClass = Value
            End Set
        End Property

        Public Property RightSeparatorBreadCrumbCssClass() As String
            Get
                Return _rightSeparatorBreadCrumbCssClass
            End Get
            Set(ByVal Value As String)
                _rightSeparatorBreadCrumbCssClass = Value
            End Set
        End Property

        Public Property MenuAlignment() As String
            Get
                Return _menuAlignment
            End Get
            Set(ByVal Value As String)
                _menuAlignment = Value
            End Set
        End Property

        Public Property ClearDefaults() As String
            Get
                Return _clearDefaults
            End Get
            Set(ByVal Value As String)
                _clearDefaults = Value
            End Set
        End Property

        Public Property DelaySubmenuLoad() As String
            Get
                Return _delaySubmenuLoad
            End Get
            Set(ByVal Value As String)
                _delaySubmenuLoad = Value
            End Set
        End Property

#End Region


#Region " Web Form Designer Generated Code "


        <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

        End Sub

        Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
            'CODEGEN: This method call is required by the Web Form Designer
            'Do not modify it using the code editor.
            InitializeComponent()
        End Sub

#End Region

        '*******************************************************
        '
        ' The Page_Load server event handler on this page is used
        ' to populate the role information for the page
        '
        '*******************************************************

        Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
            Try
                SetAttributes()

                Dim _UseSkinPathArrowImages As Boolean
                Dim _UseRootBreadcrumbArrow As Boolean
                Dim _UseSubMenuBreadcrumbArrow As Boolean
                Dim _RootBreadcrumbArrow As String
                Dim _SubMenuBreadcrumbArrow As String
                Dim _UseArrows As Boolean
                Dim _RightArrow As String
                Dim _DownArrow As String
                Dim intRootParent As Integer
                Dim _RootOnly As Boolean

                'This setting allows for skin independant images 
                'without breaking legacy skins
                If UseSkinPathArrowImages <> "" Then
                    _UseSkinPathArrowImages = Boolean.Parse(UseSkinPathArrowImages)
                Else
                    _UseSkinPathArrowImages = False
                End If
                'This setting determines if the DNN root menu will use 
                'an arrow to indicate it is the active root level tab
                If UseRootBreadCrumbArrow <> "" Then
                    _UseRootBreadcrumbArrow = Boolean.Parse(UseRootBreadCrumbArrow)
                Else
                    _UseRootBreadcrumbArrow = True
                End If
                'This setting determines if the DNN sub-menus will use an 
                'arrow to indicate it is a member of the Breadcrumb tabs
                If UseSubMenuBreadCrumbArrow <> "" Then
                    _UseSubMenuBreadcrumbArrow = Boolean.Parse(UseSubMenuBreadCrumbArrow)
					If _UseSubMenuBreadcrumbArrow Then _SubMenuBreadcrumbArrow = Common.Globals.ApplicationPath & "/images/breadcrumb.gif"
				Else
					_UseSubMenuBreadcrumbArrow = False
				End If
				Dim objSkins As New UI.Skins.SkinController
				'image for root menu breadcrumb marking
				If RootBreadCrumbArrow <> "" Then
                    _RootBreadcrumbArrow = PortalSettings.ActiveTab.SkinPath & RootBreadCrumbArrow
				Else
					_RootBreadcrumbArrow = Common.Globals.ApplicationPath & "/images/breadcrumb.gif"
				End If
				'image for submenu breadcrumb marking
				If SubMenuBreadCrumbArrow <> "" Then
                    _SubMenuBreadcrumbArrow = PortalSettings.ActiveTab.SkinPath & SubMenuBreadCrumbArrow
				End If
				'This setting determines if the submenu arrows will be used
				If UseArrows <> "" Then
					_UseArrows = Boolean.Parse(UseArrows)
				Else
					_UseArrows = True
				End If
				'image for right facing arrow
				If RightArrow <> "" Then
					_RightArrow = RightArrow
				Else
					_RightArrow = "breadcrumb.gif"
				End If
				'image for down facing arrow
				If DownArrow <> "" Then
					_DownArrow = DownArrow
				Else
					_DownArrow = "menu_down.gif"
				End If
				'This setting indicates the root level for the menu
				Select Case LCase(Level)
					Case "child"
                        intRootParent = PortalSettings.ActiveTab.TabID
					Case "same"
                        intRootParent = PortalSettings.ActiveTab.ParentId
					Case Else				   'root
						intRootParent = -1
				End Select
				'This setting determines if the submenu will be shown
				If RootOnly <> "" Then
					_RootOnly = Boolean.Parse(RootOnly)
					If _RootOnly Then _UseArrows = False
				Else
					_RootOnly = False
				End If
				'Set correct image path for all separator images
				If Separator <> "" Then
					If Separator.IndexOf("src=") <> -1 Then
                        Separator = Replace(Separator, "src=""", "src=""" & PortalSettings.ActiveTab.SkinPath)
					End If
				End If

				If LeftSeparator <> "" Then
					If LeftSeparator.IndexOf("src=") <> -1 Then
                        LeftSeparator = Replace(LeftSeparator, "src=""", "src=""" & PortalSettings.ActiveTab.SkinPath)
					End If
				End If
				If RightSeparator <> "" Then
					If RightSeparator.IndexOf("src=") <> -1 Then
                        RightSeparator = Replace(RightSeparator, "src=""", "src=""" & PortalSettings.ActiveTab.SkinPath)
					End If
				End If
				If LeftSeparatorBreadCrumb <> "" Then
					If LeftSeparatorBreadCrumb.IndexOf("src=") <> -1 Then
                        LeftSeparatorBreadCrumb = Replace(LeftSeparatorBreadCrumb, "src=""", "src=""" & PortalSettings.ActiveTab.SkinPath)
					End If
				End If
				If RightSeparatorBreadCrumb <> "" Then
					If RightSeparatorBreadCrumb.IndexOf("src=") <> -1 Then
                        RightSeparatorBreadCrumb = Replace(RightSeparatorBreadCrumb, "src=""", "src=""" & PortalSettings.ActiveTab.SkinPath)
					End If
				End If
				If LeftSeparatorActive <> "" Then
					If LeftSeparatorActive.IndexOf("src=") <> -1 Then
                        LeftSeparatorActive = Replace(LeftSeparatorActive, "src=""", "src=""" & PortalSettings.ActiveTab.SkinPath)
					End If
				End If
				If RightSeparatorActive <> "" Then
					If RightSeparatorActive.IndexOf("src=") <> -1 Then
                        RightSeparatorActive = Replace(RightSeparatorActive, "src=""", "src=""" & PortalSettings.ActiveTab.SkinPath)
					End If
				End If

				' Build list of tabs to be shown to user
				Dim authorizedTabs As New ArrayList
				Dim addedTabs As Integer = 0

				Dim i As Integer
                For i = 0 To PortalSettings.DesktopTabs.Count - 1

                    Dim tab As TabInfo = CType(PortalSettings.DesktopTabs(i), TabInfo)
                    If tab.IsVisible = True And tab.IsDeleted = False Then
                        If (tab.StartDate < Now And tab.EndDate > Now) Or AdminMode = True Then
                            If PortalSecurity.IsInRoles(tab.AuthorizedRoles) = True Then
                                authorizedTabs.Add(tab)
                                addedTabs += 1
                            End If
                        End If
                    End If

                Next i

                ' generate dynamic menu
                If _UseSkinPathArrowImages = True Then
                    ctlMenu.SystemImagesPath = PortalSettings.ActiveTab.SkinPath
                Else
                    ctlMenu.SystemImagesPath = Common.Globals.ApplicationPath & "/images/"
                End If
                ctlMenu.IconImagesPath = PortalSettings.HomeDirectory
                If _UseArrows Then
                    ctlMenu.ArrowImage = _RightArrow
                    ctlMenu.RootArrow = True
                    If ctlMenu.Display = "Vertical" Then
                        ctlMenu.RootArrowImage = _RightArrow
                    Else
                        ctlMenu.RootArrowImage = _DownArrow
                    End If
                Else
                    ctlMenu.SystemImagesPath = Common.Globals.ApplicationPath & "/images/"
                    ctlMenu.ArrowImage = "spacer.gif"
                End If
                ctlMenu.SystemScriptPath = Common.Globals.ApplicationPath & "/controls/SolpartMenu/"

                Dim objTab As TabInfo
                Dim objAttribute As System.Xml.XmlAttribute
                Dim objMenuItem As Solpart.WebControls.SPMenuItemNode
                Dim RootFlag As Boolean

                For Each objTab In authorizedTabs
                    If objTab.ParentId = intRootParent Then       ' root menu
                        For i = 0 To (PortalSettings.ActiveTab.BreadCrumbs.Count - 1)
                            If objTab.TabID = CType(PortalSettings.ActiveTab.BreadCrumbs(i), TabInfo).TabID Then
                                If RootMenuItemBreadCrumbCssClass <> "" Then
                                    NextRootBreadcrumbFlag = True
                                End If
                                If RootMenuItemActiveCssClass <> "" And objTab.TabID = PortalSettings.ActiveTab.TabID Then
                                    NextRootActiveFlag = True
                                End If
                            End If
                        Next i
                        If RootFlag = True Then       'first root item has already been entered
                            AddSeparator("All")
                        Else
                            If LeftSeparator <> "" Or LeftSeparatorBreadCrumb <> "" Or LeftSeparatorActive <> "" Then
                                AddSeparator("Left")
                            End If
                            RootFlag = True
                        End If
                        PreviousRootBreadcrumbFlag = False
                        PreviousRootActiveFlag = False
                        NextRootBreadcrumbFlag = False
                        NextRootActiveFlag = False

                        If objTab.DisableLink Then
                            objMenuItem = New Solpart.WebControls.SPMenuItemNode(ctlMenu.AddMenuItem(objTab.TabID.ToString, objTab.TabName, ""))
                        Else
                            objMenuItem = New Solpart.WebControls.SPMenuItemNode(ctlMenu.AddMenuItem(objTab.TabID.ToString, objTab.TabName, objTab.FullUrl))
                        End If
                        If RootMenuItemCssClass <> "" Then
                            objMenuItem.ItemCss = RootMenuItemCssClass
                        End If
                        If RootMenuItemSelectedCssClass <> "" Then
                            objMenuItem.ItemSelectedCss = RootMenuItemSelectedCssClass
                        End If

                        If RootMenuItemLeftHtml <> "" Then
                            objMenuItem.LeftHTML = RootMenuItemLeftHtml
                        End If
                        'add image next to root breadcrumb item and set css class if any
                        For i = 0 To (PortalSettings.ActiveTab.BreadCrumbs.Count - 1)
                            If objTab.TabID = CType(PortalSettings.ActiveTab.BreadCrumbs(i), TabInfo).TabID Then
                                If _UseRootBreadcrumbArrow = True Then
                                    objMenuItem.LeftHTML += "<img alt=""*"" BORDER=""0"" src=""" & _RootBreadcrumbArrow & """>"
                                End If
                                If RootMenuItemBreadCrumbCssClass <> "" Then
                                    objMenuItem.ItemCss = RootMenuItemBreadCrumbCssClass
                                    PreviousRootBreadcrumbFlag = True
                                End If
                                If RootMenuItemActiveCssClass <> "" And objTab.TabID = PortalSettings.ActiveTab.TabID Then
                                    objMenuItem.ItemCss = RootMenuItemActiveCssClass
                                    PreviousRootActiveFlag = True
                                End If
                            End If
                        Next i
                        If RootMenuItemRightHtml <> "" Then
                            objMenuItem.RightHTML = RootMenuItemRightHtml
                        End If

                    ElseIf Not _RootOnly Then
                        Try
                            If objTab.DisableLink Then
                                objMenuItem = New Solpart.WebControls.SPMenuItemNode(ctlMenu.AddMenuItem(objTab.ParentId.ToString, objTab.TabID.ToString, "&nbsp;" & objTab.TabName, ""))
                            Else
                                objMenuItem = New Solpart.WebControls.SPMenuItemNode(ctlMenu.AddMenuItem(objTab.ParentId.ToString, objTab.TabID.ToString, "&nbsp;" & objTab.TabName, objTab.FullUrl))
                            End If

                            If SubMenuItemSelectedCssClass <> "" Then
                                objMenuItem.ItemSelectedCss = SubMenuItemSelectedCssClass
                            End If
                            If SubMenuItemLeftHtml <> "" Then
                                objMenuItem.LeftHTML = SubMenuItemLeftHtml
                            End If

                            'add image next to submenu breadcrumb item and set css class if any
                            For i = 0 To (PortalSettings.ActiveTab.BreadCrumbs.Count - 1)
                                If objTab.TabID = CType(PortalSettings.ActiveTab.BreadCrumbs(i), TabInfo).TabID Then
                                    If _UseSubMenuBreadcrumbArrow = True Then
                                        objMenuItem.LeftHTML += "<img alt=""*"" BORDER=""0"" src=""" & _SubMenuBreadcrumbArrow & """>"
                                    End If
                                    If SubMenuItemBreadCrumbCssClass <> "" Then
                                        objMenuItem.ItemCss = SubMenuItemBreadCrumbCssClass
                                    End If
                                    If SubMenuItemActiveCssClass <> "" And objTab.TabID = PortalSettings.ActiveTab.TabID Then
                                        objMenuItem.ItemCss = SubMenuItemActiveCssClass
                                    End If
                                End If
                            Next i

                            If SubMenuItemRightHtml <> "" Then
                                objMenuItem.RightHTML = SubMenuItemRightHtml
                            End If
                        Catch
                            ' throws exception if the parent tab has not been loaded ( may be related to user role security not allowing access to a parent tab )
                            objMenuItem = Nothing
                        End Try
                    Else
                        objMenuItem = Nothing
                    End If

                    ' menu icon
                    If Not objMenuItem Is Nothing Then
                        If objTab.IsAdminTab Then
                            If objTab.IconFile <> "" Then
                                objMenuItem.Image = objTab.IconFile
                                objMenuItem.ImagePath = Common.Globals.ApplicationPath & "/images/"
                            End If
                        Else
                            If objTab.IconFile <> "" Then
                                objMenuItem.Image = objTab.IconFile
                            End If
                        End If
                    End If
                    Select Case LCase(ToolTip)
                        Case "name"
                            objMenuItem.ToolTip = objTab.TabName
                        Case "title"
                            objMenuItem.ToolTip = objTab.Title
                        Case "description"
                            objMenuItem.ToolTip = objTab.Description
                        Case Else

                    End Select

                Next
                If RightSeparator <> "" Or RightSeparatorBreadCrumb <> "" Or RightSeparatorActive <> "" Then
                    AddSeparator("Right")
                End If
            Catch exc As Exception    'Module failed to load
                ProcessModuleLoadException(Me, exc)
            End Try

        End Sub
        Private Sub AddSeparator(ByVal strType As String)
            If Separator <> "" Or _
            LeftSeparator <> "" Or _
            RightSeparator <> "" Or _
            LeftSeparatorBreadCrumb <> "" Or _
            RightSeparatorBreadCrumb <> "" Or _
            LeftSeparatorActive <> "" Or _
            RightSeparatorActive <> "" Or _
            RightSeparatorActive <> "" Then
                Dim objBreak As System.Xml.XmlNode
                Dim strParent As String = ""
                Dim strSeparator As String = ""
                Dim _Separator As String = ""
                Dim _LeftSeparator As String = ""
                Dim _RightSeparator As String = ""
                Dim _SeparatorClass As String = ""
                Dim _LeftSeparatorClass As String = ""
                Dim _RightSeparatorClass As String = ""

                If LeftSeparator <> "" Or LeftSeparatorBreadCrumb <> "" Or LeftSeparatorActive <> "" Then
                    If LeftSeparatorCssClass <> "" Then
                        _LeftSeparatorClass = LeftSeparatorCssClass
                    End If
                    If LeftSeparatorBreadCrumbCssClass <> "" And NextRootBreadcrumbFlag Then
                        _LeftSeparatorClass = LeftSeparatorBreadCrumbCssClass
                    End If
                    If LeftSeparatorActiveCssClass <> "" And NextRootActiveFlag Then
                        _LeftSeparatorClass = LeftSeparatorActiveCssClass
                    End If
                    If LeftSeparator <> "" Then
                        _LeftSeparator = LeftSeparator
                    End If
                    If LeftSeparatorBreadCrumb <> "" And NextRootBreadcrumbFlag Then
                        _LeftSeparator = LeftSeparatorBreadCrumb
                    End If
                    If LeftSeparatorActive <> "" And NextRootActiveFlag Then
                        _LeftSeparator = LeftSeparatorActive
                    End If
                End If
                If Separator <> "" Then
                    If SeparatorCssClass <> "" Then
                        _SeparatorClass = SeparatorCssClass
                    End If
                    _Separator = Separator
                End If
                If RightSeparator <> "" Or RightSeparatorBreadCrumb <> "" Or RightSeparatorActive <> "" Then
                    If RightSeparatorCssClass <> "" Then
                        _RightSeparatorClass = RightSeparatorCssClass
                    End If
                    If RightSeparatorBreadCrumbCssClass <> "" And PreviousRootBreadcrumbFlag Then
                        _RightSeparatorClass = RightSeparatorBreadCrumbCssClass
                    End If
                    If RightSeparatorActiveCssClass <> "" And PreviousRootActiveFlag Then
                        _RightSeparatorClass = RightSeparatorActiveCssClass
                    End If
                    If RightSeparator <> "" Then
                        _RightSeparator = RightSeparator
                    End If
                    If RightSeparatorBreadCrumb <> "" And PreviousRootBreadcrumbFlag Then
                        _RightSeparator = RightSeparatorBreadCrumb
                    End If
                    If RightSeparatorActive <> "" And PreviousRootActiveFlag Then
                        _RightSeparator = RightSeparatorActive
                    End If

                End If
                strSeparator = "<table summary=""Table for menu separator design"" border=""0"" cellpadding=""0"" cellspacing=""0""><tr>"
                If _RightSeparator <> "" And strType <> "Left" Then
                    If _RightSeparatorClass <> "" Then
                        strSeparator += "<td class = """ & _RightSeparatorClass & """>"
                    Else
                        strSeparator += "<td>"
                    End If
                    strSeparator += _RightSeparator & "</td>"
                End If
                If _Separator <> "" And strType <> "Left" And strType <> "Right" Then
                    If _SeparatorClass <> "" Then
                        strSeparator += "<td class = """ & _SeparatorClass & """>"
                    Else
                        strSeparator += "<td>"
                    End If
                    strSeparator += _Separator & "</td>"
                End If
                If _LeftSeparator <> "" And strType <> "Right" Then
                    If _LeftSeparatorClass <> "" Then
                        strSeparator += "<td class = """ & _LeftSeparatorClass & """>"
                    Else
                        strSeparator += "<td>"
                    End If
                    strSeparator += _LeftSeparator & "</td>"
                End If
                strSeparator += "</tr></table>"
                objBreak = ctlMenu.AddBreak(strParent, strSeparator)
            End If
        End Sub
        Private Sub SetAttributes()
            ctlMenu.SeparateCSS = True
            ctlMenu.SelectedBorderColor = Nothing

            If ClearDefaults <> "" Then
                If Boolean.Parse(ClearDefaults) = True Then
                    ctlMenu.SelectedBorderColor = Nothing
                    ctlMenu.SelectedForeColor = Nothing
                    ctlMenu.HighlightColor = Nothing
                    ctlMenu.IconBackgroundColor = Nothing
                    ctlMenu.ShadowColor = Nothing
                    ctlMenu.SelectedColor = Nothing
                    ctlMenu.BackColor = Nothing
                    ctlMenu.ForeColor = Nothing
                End If
            End If
            If SeparateCss <> "" Then
                ctlMenu.SeparateCSS = Convert.ToBoolean(SeparateCss)
            End If
            If BackColor <> "" Then
                ctlMenu.BackColor = Color.FromName(BackColor)
            End If
            If ForeColor <> "" Then
                ctlMenu.ForeColor = Color.FromName(ForeColor)
            End If
            If HighlightColor <> "" Then
                ctlMenu.HighlightColor = Color.FromName(HighlightColor)
            End If
            If IconBackgroundColor <> "" Then
                ctlMenu.IconBackgroundColor = Color.FromName(IconBackgroundColor)
            End If
            If SelectedBorderColor <> "" Then
                ctlMenu.SelectedBorderColor = Color.FromName(SelectedBorderColor)
            End If
            If SelectedColor <> "" Then
                ctlMenu.SelectedColor = Color.FromName(SelectedColor)
            End If
            If SelectedForeColor <> "" Then
                ctlMenu.SelectedForeColor = Color.FromName(SelectedForeColor)
            End If
            If Display <> "" Then
                ctlMenu.Display = Display
            End If
            If MenuBarHeight <> "" Then
                ctlMenu.MenuBarHeight = Convert.ToInt64(MenuBarHeight)
            End If
            If MenuBorderWidth <> "" Then
                ctlMenu.MenuBorderWidth = Convert.ToInt32(MenuBorderWidth)
            End If
            If MenuItemHeight <> "" Then
                ctlMenu.MenuItemHeight = Convert.ToInt64(MenuItemHeight)
            End If
            If ForceDownLevel <> "" Then
                ctlMenu.ForceDownlevel = Convert.ToBoolean(ForceDownLevel)
            End If
            If DelaySubmenuLoad <> "" Then
                ctlMenu.DelaySubmenuLoad = Convert.ToBoolean(DelaySubmenuLoad)
            End If
            If Moveable <> "" Then
                ctlMenu.Moveable = Convert.ToBoolean(Moveable)
            End If
            If IconWidth <> "" Then
                ctlMenu.IconWidth = Convert.ToInt64(IconWidth)
            End If
            If MenuEffectsShadowColor <> "" Then
                ctlMenu.MenuEffects.ShadowColor = Color.FromName(MenuEffectsShadowColor)
            End If
            If MenuEffectsMouseOutHideDelay <> "" Then
                ctlMenu.MenuEffects.MouseOutHideDelay = Convert.ToInt32(MenuEffectsMouseOutHideDelay)
            End If
            If MouseOutHideDelay <> "" Then
                ctlMenu.MenuEffects.MouseOutHideDelay = Convert.ToInt32(MouseOutHideDelay)
            End If
            If MenuEffectsMouseOverDisplay <> "" Then
                Select Case LCase(MenuEffectsMouseOverDisplay)
                    Case "highlight"
                        ctlMenu.MenuEffects.MouseOverDisplay = Solpart.WebControls.MenuEffectsMouseOverDisplay.Highlight
                    Case "none"
                        ctlMenu.MenuEffects.MouseOverDisplay = Solpart.WebControls.MenuEffectsMouseOverDisplay.None
                    Case "outset"
                        ctlMenu.MenuEffects.MouseOverDisplay = Solpart.WebControls.MenuEffectsMouseOverDisplay.Outset
                End Select
            End If
            If MenuEffectsMouseOverExpand <> "" Then
                ctlMenu.MenuEffects.MouseOverExpand = Convert.ToBoolean(MenuEffectsMouseOverExpand)
            End If
            If MenuEffectsStyle <> "" Then
                ctlMenu.MenuEffects.Style.Concat(ctlMenu.MenuEffects.Style.ToString, MenuEffectsStyle)
            End If
            If FontNames <> "" Then
                ctlMenu.Font.Names = FontNames.Split(Convert.ToChar(";"))
            End If
            If FontSize <> "" Then
                ctlMenu.Font.Size = FontUnit.Parse(FontSize)
            End If
            If FontBold <> "" Then
                ctlMenu.Font.Bold = Convert.ToBoolean(FontBold)
            End If
            If MenuEffectsShadowStrength <> "" Then
                ctlMenu.MenuEffects.ShadowStrength = Convert.ToInt32(MenuEffectsShadowStrength)
            End If
            If MenuEffectsMenuTransition <> "" Then
                ctlMenu.MenuEffects.MenuTransition = MenuEffectsMenuTransition
            End If
            If MenuEffectsMenuTransitionLength <> "" Then
                ctlMenu.MenuEffects.MenuTransitionLength = Convert.ToDouble(MenuEffectsMenuTransitionLength)
            End If
            If MenuEffectsShadowDirection <> "" Then
                ctlMenu.MenuEffects.ShadowDirection = MenuEffectsShadowDirection
            End If
            If ForceFullMenuList <> "" Then
                ctlMenu.ForceFullMenuList = Convert.ToBoolean(ForceFullMenuList)
            End If
            If ctlMenu.SeparateCSS = True Then
                If MenuBarCssClass <> "" Then
                    ctlMenu.MenuCSS.MenuBar = MenuBarCssClass
                Else
                    ctlMenu.MenuCSS.MenuBar = "MainMenu_MenuBar"
                End If
                If MenuContainerCssClass <> "" Then
                    ctlMenu.MenuCSS.MenuContainer = MenuContainerCssClass
                Else
                    ctlMenu.MenuCSS.MenuContainer = "MainMenu_MenuContainer"
                End If
                If MenuItemCssClass <> "" Then
                    ctlMenu.MenuCSS.MenuItem = MenuItemCssClass
                Else
                    ctlMenu.MenuCSS.MenuItem = "MainMenu_MenuItem"
                End If
                If MenuIconCssClass <> "" Then
                    ctlMenu.MenuCSS.MenuIcon = MenuIconCssClass
                Else
                    ctlMenu.MenuCSS.MenuIcon = "MainMenu_MenuIcon"
                End If
                If SubMenuCssClass <> "" Then
                    ctlMenu.MenuCSS.SubMenu = SubMenuCssClass
                Else
                    ctlMenu.MenuCSS.SubMenu = "MainMenu_SubMenu"
                End If
                If MenuBreakCssClass <> "" Then
                    ctlMenu.MenuCSS.MenuBreak = MenuBreakCssClass
                Else
                    ctlMenu.MenuCSS.MenuBreak = "MainMenu_MenuBreak"
                End If
                If MenuItemSelCssClass <> "" Then
                    ctlMenu.MenuCSS.MenuItemSel = MenuItemSelCssClass
                Else
                    ctlMenu.MenuCSS.MenuItemSel = "MainMenu_MenuItemSel"
                End If
                If MenuArrowCssClass <> "" Then
                    ctlMenu.MenuCSS.MenuArrow = MenuArrowCssClass
                Else
                    ctlMenu.MenuCSS.MenuArrow = "MainMenu_MenuArrow"
                End If
                If MenuRootArrowCssClass <> "" Then
                    ctlMenu.MenuCSS.RootMenuArrow = MenuRootArrowCssClass
                Else
                    ctlMenu.MenuCSS.RootMenuArrow = "MainMenu_RootMenuArrow"
                End If
            End If
            If MenuAlignment <> "" Then
                Select Case LCase(MenuAlignment)
                    Case "right"
                        ctlMenu.MenuAlignment = "Right"
                    Case "center"
                        ctlMenu.MenuAlignment = "Center"
                    Case "justify"
                        ctlMenu.MenuAlignment = "Justify"
                    Case Else
                        ctlMenu.MenuAlignment = "Left"
                End Select
            End If
        End Sub

    End Class

End Namespace
