'
' DotNetNuke - http://www.dotnetnuke.com
' Copyright (c) 2002-2005
' by Perpetual Motion Interactive Systems Inc. ( http://www.perpetualmotion.ca )
'
' Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated 
' documentation files (the "Software"), to deal in the Software without restriction, including without limitation 
' the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and 
' to permit persons to whom the Software is furnished to do so, subject to the following conditions:
'
' The above copyright notice and this permission notice shall be included in all copies or substantial portions 
' of the Software.
'
' THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED 
' TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL 
' THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF 
' CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
' DEALINGS IN THE SOFTWARE.
'
Imports DotNetNuke.Entities.Tabs
Imports DotNetNuke.UI.Utilities
Imports DotNetNuke.UI.WebControls

Namespace DotNetNuke.UI.Skins.Controls

    ''' -----------------------------------------------------------------------------
    ''' Project	 : DotNetNuke
    ''' Class	 : TreeViewMenu
    ''' -----------------------------------------------------------------------------
    ''' <summary>
    ''' TreeViewMenu is a Skin Object that creates a Menu using the DNN Treeview Control
    ''' to provide a Windows Explore like Menu.
    ''' </summary>
    ''' <remarks></remarks>
    ''' <history>
    ''' 	[cnurse]	12/8/2004	created
    ''' </history>
    ''' -----------------------------------------------------------------------------
    Public MustInherit Class TreeViewMenu

        Inherits UI.Skins.SkinObjectBase

#Region "Controls"
        Protected WithEvents tblMain As System.Web.UI.HtmlControls.HtmlTable
        Protected WithEvents tblHeader As System.Web.UI.HtmlControls.HtmlTable
        Protected WithEvents cellHeader As System.Web.UI.HtmlControls.HtmlTableCell
        Protected WithEvents lblHeader As System.Web.UI.WebControls.Label
        Protected WithEvents cellBody As System.Web.UI.HtmlControls.HtmlTableCell
        Protected WithEvents DNNTree As DNNTree
#End Region

#Region "Enums"

        Private Enum eImageType
            FolderClosed = 0
            FolderOpen = 1
            Page = 2
            GotoParent = 3
        End Enum

#End Region

#Region "Private Members"
        Private _bodyCssClass As String = ""
        Private _cssClass As String = ""
        Private _headerCssClass As String = ""
        Private _headerTextCssClass As String = "Head"
        Private _headerText As String = ""
        Private _resourceKey As String = ""
        Private _includeHeader As Boolean = True
        Private _level As String
        Private _rootOnly As String
        Private _nodeChildCssClass As String = "Normal"
        Private _nodeClosedImage As String = "~/images/folderclosed.gif"
        Private _nodeCollapseImage As String = "~/images/min.gif"
        Private _nodeCssClass As String = "Normal"
        Private _nodeExpandImage As String = "~/images/max.gif"
        Private _nodeLeafImage As String = "~/images/file.gif"
        Private _nodeOpenImage As String = "~/images/folderopen.gif"
        Private _nodeOverCssClass As String = "Normal"
        Private _nodeSelectedCssClass As String = "Normal"
        Private _nowrap As Boolean = False
        Private _treeCssClass As String = ""
        Private _treeGoUpImage As String = "~/images/folderup.gif"
        Private _treeIndentWidth As Integer = 10
        Private _width As String = "100%"

        Const MyFileName As String = "TreeViewMenu.ascx"

#End Region

#Region "Public Properties"

        Public Property BodyCssClass() As String
            Get
                Return _bodyCssClass
            End Get
            Set(ByVal Value As String)
                _bodyCssClass = Value
            End Set
        End Property

        Public Property CssClass() As String
            Get
                Return _cssClass
            End Get
            Set(ByVal Value As String)
                _cssClass = Value
            End Set
        End Property

        Public Property HeaderCssClass() As String
            Get
                Return _headerCssClass
            End Get
            Set(ByVal Value As String)
                _headerCssClass = Value
            End Set
        End Property

        Public Property HeaderTextCssClass() As String
            Get
                Return _headerTextCssClass
            End Get
            Set(ByVal Value As String)
                _headerTextCssClass = Value
            End Set
        End Property

        Public Property HeaderText() As String
            Get
                Return _headerText
            End Get
            Set(ByVal Value As String)
                _headerText = Value
            End Set
        End Property

        Public Property IncludeHeader() As Boolean
            Get
                Return _includeHeader
            End Get
            Set(ByVal Value As Boolean)
                _includeHeader = Value
            End Set
        End Property

        Public Property Level() As String
            Get
                Return _level
            End Get
            Set(ByVal Value As String)
                _level = Value
            End Set
        End Property

        Public Property NodeChildCssClass() As String
            Get
                Return _nodeChildCssClass
            End Get
            Set(ByVal Value As String)
                _nodeChildCssClass = Value
            End Set
        End Property

        Public Property NodeClosedImage() As String
            Get
                Return _nodeClosedImage
            End Get
            Set(ByVal Value As String)
                _nodeClosedImage = Value
            End Set
        End Property

        Public Property NodeCollapseImage() As String
            Get
                Return _nodeCollapseImage
            End Get
            Set(ByVal Value As String)
                _nodeCollapseImage = Value
            End Set
        End Property

        Public Property NodeCssClass() As String
            Get
                Return _nodeCssClass
            End Get
            Set(ByVal Value As String)
                _nodeCssClass = Value
            End Set
        End Property

        Public Property NodeExpandImage() As String
            Get
                Return _nodeExpandImage
            End Get
            Set(ByVal Value As String)
                _nodeExpandImage = Value
            End Set
        End Property

        Public Property NodeLeafImage() As String
            Get
                Return _nodeLeafImage
            End Get
            Set(ByVal Value As String)
                _nodeLeafImage = Value
            End Set
        End Property

        Public Property NodeOpenImage() As String
            Get
                Return _nodeOpenImage
            End Get
            Set(ByVal Value As String)
                _nodeOpenImage = Value
            End Set
        End Property

        Public Property NodeOverCssClass() As String
            Get
                Return _nodeOverCssClass
            End Get
            Set(ByVal Value As String)
                _nodeOverCssClass = Value
            End Set
        End Property

        Public Property NodeSelectedCssClass() As String
            Get
                Return _nodeSelectedCssClass
            End Get
            Set(ByVal Value As String)
                _nodeSelectedCssClass = Value
            End Set
        End Property

        Public Property NoWrap() As Boolean
            Get
                Return _nowrap
            End Get
            Set(ByVal Value As Boolean)
                _nowrap = Value
            End Set
        End Property

        Public Property ResourceKey() As String
            Get
                Return _resourceKey
            End Get
            Set(ByVal Value As String)
                _resourceKey = Value
            End Set
        End Property

        Public Property RootOnly() As String
            Get
                Return _rootOnly
            End Get
            Set(ByVal Value As String)
                _rootOnly = Value
            End Set
        End Property

        Public Property TreeCssClass() As String
            Get
                Return _treeCssClass
            End Get
            Set(ByVal Value As String)
                _treeCssClass = Value
            End Set
        End Property

        Public Property TreeGoUpImage() As String
            Get
                Return _treeGoUpImage
            End Get
            Set(ByVal Value As String)
                _treeGoUpImage = Value
            End Set
        End Property

        Public Property TreeIndentWidth() As Integer
            Get
                Return _treeIndentWidth
            End Get
            Set(ByVal Value As Integer)
                _treeIndentWidth = Value
            End Set
        End Property

        Public Property Width() As String
            Get
                Return _width
            End Get
            Set(ByVal Value As String)
                _width = Value
            End Set
        End Property

#End Region

#Region "Private Methods"

        ''' -----------------------------------------------------------------------------
        ''' <summary>
        ''' Adds node to tree
        ''' </summary>
        ''' <param name="strName">Name of page to display</param>
        ''' <param name="strKey">Masked Key of page location</param>
        ''' <param name="eImage">Type of image</param>
        ''' <param name="objNodes">Node collection to add to</param>
        ''' <returns></returns>
        ''' <remarks>
        ''' </remarks>
        ''' <history>
        '''     [cnurse]        12/8/2004   Created
		'''		[Jon Henning]	3/23/2005	Tree navigation bug fix where tab that redirected to another tab was not handled.  No longer doing a postback for all nodes that have children.
        ''' </history>
        ''' -----------------------------------------------------------------------------
        Private Function AddNode(ByVal tab As TabInfo, ByVal tabs As ArrayList, ByVal objNodes As TreeNodeCollection) As TreeNode
            Dim objNode As New TreeNode(tab.TabName)
            objNodes.Add(objNode)

            objNode.Key = tab.TabID.ToString
            objNode.ToolTip = tab.Description
            If tab.HasChildren Then
                objNode.ImageIndex = eImageType.FolderClosed
            Else
                objNode.ImageIndex = eImageType.Page
                If tab.IsAdminTab Then
                    If tab.IconFile <> "" Then
                        DNNTree.ImageList.Add(ResolveUrl(Common.Globals.ApplicationPath & "/images/" & tab.IconFile))
                        objNode.ImageIndex = DNNTree.ImageList.Count - 1
                    End If
                Else
                    If tab.IconFile <> "" Then
                        DNNTree.ImageList.Add(ResolveUrl(tab.IconFile))
                        objNode.ImageIndex = DNNTree.ImageList.Count - 1
                    End If
                End If
            End If
            objNode.CssClass = NodeCssClass
            If tab.DisableLink Then
                objNode.ClickAction = eClickAction.Expand
			Else
				objNode.NavigateUrl = tab.FullUrl
			End If

			'Parse looking for children of this tab
			Dim objTab As TabInfo
			Dim objChildNode As TreeNode
			For Each objTab In tabs
				If objTab.ParentId = tab.TabID Then				   ' child menu
					objChildNode = AddNode(objTab, tabs, objNode.TreeNodes)
				End If
			Next

			Return objNode

        End Function

        ''' -----------------------------------------------------------------------------
        ''' <summary>
        ''' The BuildTree helper method is used to build the tree
        ''' </summary>
        ''' <remarks>
        ''' </remarks>
        ''' <history>
        '''     [cnurse]        12/8/2004   Created
        ''' </history>
        ''' -----------------------------------------------------------------------------
        Private Sub BuildTree()

            Dim tabs As New ArrayList
            Dim objNode As TreeNode
            Dim intRootParent As Integer
            Dim objTab As TabInfo
            Dim addUpNode As Boolean
            Dim i As Integer

            'Clear the Tree Nodes Collection
            DNNTree.TreeNodes.Clear()

            'This setting indicates the root level for the menu
            Select Case LCase(Level)
                Case "child"
                    intRootParent = PortalSettings.ActiveTab.TabID
                    addUpNode = True
                Case "parent"
                    intRootParent = PortalSettings.ActiveTab.TabID
                    If PortalSettings.ActiveTab.ParentId > -1 Then
                        addUpNode = True
                    Else
                        addUpNode = False
                    End If
                Case "same"
                    intRootParent = PortalSettings.ActiveTab.ParentId
                    addUpNode = True
                Case Else       'root
                    intRootParent = -1
                    addUpNode = False
            End Select

            ' Build list of tabs to be shown to user
            For i = 0 To PortalSettings.DesktopTabs.Count - 1
                Dim tab As TabInfo = CType(PortalSettings.DesktopTabs(i), TabInfo)
                If tab.IsVisible = True And tab.IsDeleted = False Then
                    If (tab.StartDate < Now And tab.EndDate > Now) Or AdminMode = True Then
                        If PortalSecurity.IsInRoles(tab.AuthorizedRoles) = True Then
                            tabs.Add(tab)
                        End If
                    End If
                End If
            Next i

            'add goto Parent node?
            If addUpNode And intRootParent > -1 Then
                objNode = New TreeNode(Services.Localization.Localization.GetString("Parent", Services.Localization.Localization.GetResourceFile(Me, MyFileName)))
                DNNTree.TreeNodes.Add(objNode)

                objNode.Key = PortalSettings.ActiveTab.ParentId.ToString
                objNode.ToolTip = Services.Localization.Localization.GetString("GoUp", Services.Localization.Localization.GetResourceFile(Me, MyFileName))
                objNode.ImageIndex = eImageType.GotoParent
                objNode.CssClass = NodeCssClass
                objNode.ClickAction = eClickAction.PostBack
            End If


            For Each objTab In tabs
                If LCase(Level) = "parent" Then
                    If objTab.TabID = intRootParent Then        ' parent menu
                        objNode = AddNode(objTab, tabs, DNNTree.TreeNodes)
                    End If
                Else
                    If objTab.ParentId = intRootParent Then     ' root menu
                        objNode = AddNode(objTab, tabs, DNNTree.TreeNodes)
                    End If
                End If
            Next

            objNode = DNNTree.SelectNodeByKey(PortalSettings.ActiveTab.TabID.ToString)
            If Not objNode Is Nothing Then
                objNode.Expand()
            End If

        End Sub

        ''' -----------------------------------------------------------------------------
        ''' <summary>
        ''' Sets common properties on DNNTree control
        ''' </summary>
        ''' <remarks>
        ''' </remarks>
        ''' <history>
        '''     [cnurse]        12/8/2004   Created
        ''' </history>
        ''' -----------------------------------------------------------------------------
        Private Sub InitializeTree()
            DNNTree.SystemImagesPath = ResolveUrl("~/images/")
            DNNTree.ImageList.Add(ResolveUrl(NodeClosedImage))
            DNNTree.ImageList.Add(ResolveUrl(NodeOpenImage))
            DNNTree.ImageList.Add(ResolveUrl(NodeLeafImage))
            DNNTree.ImageList.Add(ResolveUrl(TreeGoUpImage))
            DNNTree.IndentWidth = TreeIndentWidth
            DNNTree.CollapsedNodeImage = ResolveUrl(NodeExpandImage)
            DNNTree.ExpandedNodeImage = ResolveUrl(NodeCollapseImage)
            DNNTree.DefaultChildNodeCssClass = NodeChildCssClass
            DNNTree.DefaultNodeCssClass = NodeCssClass
            DNNTree.DefaultNodeCssClassOver = NodeOverCssClass
            DNNTree.DefaultNodeCssClassSelected = NodeSelectedCssClass
            DNNTree.CssClass = TreeCssClass

        End Sub


#End Region

#Region "Event Handlers"

        ''' -----------------------------------------------------------------------------
        ''' <summary>
        ''' The Page_Load server event handler on this user control is used
        ''' to populate the tree with the Pages.
        ''' </summary>
        ''' <param name="sender"></param>
        ''' <param name="e"></param>
        ''' <remarks>
        ''' </remarks>
        ''' <history>
        ''' 	[cnurse]	12/9/2004	Created
        ''' </history>
        ''' -----------------------------------------------------------------------------
        Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
            Try

                If Page.IsPostBack = False Then
                    InitializeTree()
                    BuildTree()

                    'Main Table Properties
                    If Me.Width <> "" Then
                        tblMain.Width = Me.Width
                    End If
                    If Me.CssClass <> "" Then
                        tblMain.Attributes.Add("class", Me.CssClass)
                    End If

                    'Header Properties
                    If Me.HeaderCssClass <> "" Then
                        cellHeader.Attributes.Add("class", Me.HeaderCssClass)
                    End If
                    If Me.HeaderTextCssClass <> "" Then
                        lblHeader.CssClass = Me.HeaderTextCssClass
                    End If

                    'Header Text (if set)
                    If Me.HeaderText <> "" Then
                        lblHeader.Text = Me.HeaderText
                    End If

                    'ResourceKey overrides if found
                    If Me.ResourceKey <> "" Then
                        Dim strHeader As String = Services.Localization.Localization.GetString(Me.ResourceKey, Services.Localization.Localization.GetResourceFile(Me, MyFileName))
                        If strHeader <> "" Then
                            lblHeader.Text = Services.Localization.Localization.GetString(Me.ResourceKey, Services.Localization.Localization.GetResourceFile(Me, MyFileName))
                        End If
                    End If

                    'If still not set get default key
                    If lblHeader.Text = "" Then
                        Dim strHeader As String = Services.Localization.Localization.GetString("Title", Services.Localization.Localization.GetResourceFile(Me, MyFileName))
                        If strHeader <> "" Then
                            lblHeader.Text = Services.Localization.Localization.GetString("Title", Services.Localization.Localization.GetResourceFile(Me, MyFileName))
                        Else
                            lblHeader.Text = "Site Navigation"
                        End If
                    End If
                    tblHeader.Visible = Me.IncludeHeader

                    'Main Panel Properties
                    If Me.BodyCssClass <> "" Then
                        cellBody.Attributes.Add("class", Me.BodyCssClass)
                    End If
                    cellBody.NoWrap = Me.NoWrap
                    If Me.TreeCssClass <> "" Then
                        DNNTree.CssClass = Me.TreeCssClass
                    End If

                End If

            Catch exc As Exception    'Module failed to load
                ProcessModuleLoadException(Me, exc)
            End Try

        End Sub

        ''' -----------------------------------------------------------------------------
        ''' <summary>
        ''' The DNNTree_NodeClick server event handler on this user control runs when a
        ''' Node (Page) in the TreeView is clicked
        ''' </summary>
        ''' <param name="sender"></param>
        ''' <param name="e"></param>
        ''' <remarks>The event only fires when the Node contains child nodes, as leaf nodes
        ''' have their NavigateUrl Property set.
        ''' </remarks>
        ''' <history>
        ''' 	[cnurse]	12/9/2004	Created
        ''' </history>
        ''' -----------------------------------------------------------------------------
        Private Sub DNNTree_NodeClick(ByVal source As Object, ByVal e As WebControls.DNNTreeNodeClickEventArgs) Handles DNNTree.NodeClick

            Dim objNode As TreeNode = e.Node
            Response.Redirect(ApplicationURL(Integer.Parse(e.Node.Key)), True)

        End Sub
#End Region

#Region " Web Form Designer Generated Code "


        <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

        End Sub

        Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
            'CODEGEN: This method call is required by the Web Form Designer
            'Do not modify it using the code editor.
            InitializeComponent()
        End Sub

#End Region

    End Class

End Namespace
